# Code generated by qwick.

from ebcc import numpy as np
from ebcc.util import pack_2e, einsum, Namespace
from ebcc.precision import types

def energy(f=None, v=None, nocc=None, nvir=None, naux=None, t1=None, t2=None, **kwargs):
    # energy
    x0 = np.zeros((naux,), dtype=types[float])
    x0 += einsum(t1, (0, 1), v.xov, (2, 0, 1), (2,))
    x1 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x1 += einsum(t2, (0, 1, 2, 3), (0, 1, 3, 2)) * -0.5
    x1 += einsum(t2, (0, 1, 2, 3), (0, 1, 2, 3))
    x2 = np.zeros((nocc, nvir, naux), dtype=types[float])
    x2 += einsum(x0, (0,), t1, (1, 2), (1, 2, 0))
    del x0
    x2 += einsum(v.xov, (0, 1, 2), x1, (1, 3, 2, 4), (3, 4, 0))
    del x1
    e_cc = 0
    e_cc += einsum(v.xov, (0, 1, 2), x2, (1, 2, 0), ()) * 2.0
    del x2
    x3 = np.zeros((nocc, nocc, naux), dtype=types[float])
    x3 += einsum(t1, (0, 1), v.xov, (2, 3, 1), (0, 3, 2))
    x4 = np.zeros((nocc, nvir), dtype=types[float])
    x4 += einsum(f.ov, (0, 1), (0, 1))
    x4 += einsum(v.xov, (0, 1, 2), x3, (1, 3, 0), (3, 2)) * -0.5
    del x3
    e_cc += einsum(t1, (0, 1), x4, (0, 1), ()) * 2.0
    del x4

    return e_cc

def update_amps(f=None, v=None, nocc=None, nvir=None, naux=None, t1=None, t2=None, **kwargs):
    # T amplitudes
    t1new = np.zeros((nocc, nvir), dtype=types[float])
    t1new += einsum(f.vv, (0, 1), t1, (2, 1), (2, 0))
    t1new += einsum(f.ov, (0, 1), (0, 1))
    x0 = np.zeros((naux,), dtype=types[float])
    x0 += einsum(t1, (0, 1), v.xov, (2, 0, 1), (2,))
    x1 = np.zeros((nocc, nvir), dtype=types[float])
    x1 += einsum(x0, (0,), v.xov, (0, 1, 2), (1, 2))
    t1new += einsum(x1, (0, 1), (0, 1)) * 2.0
    x2 = np.zeros((nocc, nvir, naux), dtype=types[float])
    x2 += einsum(t1, (0, 1), v.xoo, (2, 3, 0), (3, 1, 2))
    x3 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x3 += einsum(t1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    x3 += einsum(t2, (0, 1, 2, 3), (0, 1, 3, 2)) * -2.0
    x3 += einsum(t2, (0, 1, 2, 3), (0, 1, 2, 3))
    x4 = np.zeros((nocc, nvir, naux), dtype=types[float])
    x4 += einsum(x2, (0, 1, 2), (0, 1, 2)) * 0.5
    x4 += einsum(x0, (0,), t1, (1, 2), (1, 2, 0)) * -1.0
    x4 += einsum(v.xov, (0, 1, 2), x3, (1, 3, 4, 2), (3, 4, 0)) * 0.5
    del x3
    t1new += einsum(v.xvv, (0, 1, 2), x4, (3, 2, 0), (3, 1)) * -2.0
    del x4
    x5 = np.zeros((nocc, nocc, naux), dtype=types[float])
    x5 += einsum(t1, (0, 1), v.xov, (2, 3, 1), (0, 3, 2))
    x6 = np.zeros((nocc, nocc, naux), dtype=types[float])
    x6 += einsum(v.xoo, (0, 1, 2), (1, 2, 0))
    x6 += einsum(x5, (0, 1, 2), (1, 0, 2))
    x7 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x7 += einsum(v.xov, (0, 1, 2), x6, (3, 4, 0), (4, 1, 3, 2))
    del x6
    x8 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x8 += einsum(t2, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    x8 += einsum(t2, (0, 1, 2, 3), (0, 1, 2, 3)) * 2.0
    t1new += einsum(x7, (0, 1, 2, 3), x8, (1, 2, 3, 4), (0, 4)) * -1.0
    del x7
    x9 = np.zeros((nocc, nvir), dtype=types[float])
    x9 += einsum(v.xov, (0, 1, 2), x5, (1, 3, 0), (3, 2))
    x10 = np.zeros((nocc, nvir), dtype=types[float])
    x10 += einsum(f.ov, (0, 1), (0, 1)) * 0.5
    x10 += einsum(x1, (0, 1), (0, 1))
    x10 += einsum(x9, (0, 1), (0, 1)) * -0.5
    t1new += einsum(x10, (0, 1), x8, (0, 2, 1, 3), (2, 3)) * 2.0
    x11 = np.zeros((nocc, nocc), dtype=types[float])
    x11 += einsum(x0, (0,), v.xoo, (0, 1, 2), (1, 2))
    x12 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x12 += einsum(t2, (0, 1, 2, 3), (0, 1, 3, 2)) * -0.5
    x12 += einsum(t2, (0, 1, 2, 3), (0, 1, 2, 3))
    x13 = np.zeros((nocc, nvir, naux), dtype=types[float])
    x13 += einsum(v.xov, (0, 1, 2), x12, (1, 3, 2, 4), (3, 4, 0)) * 2.0
    del x12
    x14 = np.zeros((nocc, nvir, naux), dtype=types[float])
    x14 += einsum(x2, (0, 1, 2), (0, 1, 2)) * -1.0
    x14 += einsum(x0, (0,), t1, (1, 2), (1, 2, 0)) * 2.0
    x14 += einsum(x13, (0, 1, 2), (0, 1, 2))
    x15 = np.zeros((nocc, nvir), dtype=types[float])
    x15 += einsum(f.ov, (0, 1), (0, 1))
    x15 += einsum(x9, (0, 1), (0, 1)) * -1.0
    x16 = np.zeros((nocc, nocc), dtype=types[float])
    x16 += einsum(f.oo, (0, 1), (0, 1))
    x16 += einsum(x11, (0, 1), (1, 0)) * 2.0
    x16 += einsum(v.xov, (0, 1, 2), x14, (3, 2, 0), (1, 3))
    del x14
    x16 += einsum(t1, (0, 1), x15, (2, 1), (2, 0))
    del x15
    t1new += einsum(t1, (0, 1), x16, (0, 2), (2, 1)) * -1.0
    del x16
    x17 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x17 += einsum(v.xov, (0, 1, 2), v.xov, (0, 3, 4), (1, 3, 2, 4))
    t2new = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    t2new += einsum(x17, (0, 1, 2, 3), (1, 0, 3, 2))
    x18 = np.zeros((nocc, nocc, nocc, nocc), dtype=types[float])
    x18 += einsum(t2, (0, 1, 2, 3), x17, (4, 5, 3, 2), (0, 1, 5, 4))
    t2new += einsum(t2, (0, 1, 2, 3), x18, (4, 5, 0, 1), (5, 4, 3, 2))
    x19 = np.zeros((nocc, nvir, naux), dtype=types[float])
    x19 += einsum(v.xov, (0, 1, 2), t2, (3, 1, 2, 4), (3, 4, 0))
    t2new += einsum(x19, (0, 1, 2), x19, (3, 4, 2), (0, 3, 1, 4))
    x20 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x20 += einsum(t2, (0, 1, 2, 3), x17, (1, 4, 5, 2), (0, 4, 3, 5))
    t2new += einsum(t2, (0, 1, 2, 3), x20, (4, 1, 5, 2), (4, 0, 3, 5))
    x21 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x21 += einsum(t1, (0, 1), x18, (2, 3, 4, 0), (2, 3, 4, 1))
    del x18
    t2new += einsum(t1, (0, 1), x21, (2, 3, 0, 4), (2, 3, 1, 4))
    del x21
    x22 = np.zeros((nvir, nvir, nvir, nvir), dtype=types[float])
    x22 += einsum(v.xvv, (0, 1, 2), v.xvv, (0, 3, 4), (1, 3, 4, 2))
    t2new += einsum(t2, (0, 1, 2, 3), x22, (4, 2, 5, 3), (0, 1, 5, 4))
    del x22
    x23 = np.zeros((nocc, nvir, naux), dtype=types[float])
    x23 += einsum(t1, (0, 1), v.xvv, (2, 3, 1), (0, 3, 2))
    t2new += einsum(x23, (0, 1, 2), x23, (3, 4, 2), (0, 3, 1, 4))
    x24 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x24 += einsum(f.vv, (0, 1), t2, (2, 3, 4, 1), (2, 3, 0, 4))
    x25 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x25 += einsum(v.xoo, (0, 1, 2), v.xvv, (0, 3, 4), (1, 2, 3, 4))
    x26 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x26 += einsum(t2, (0, 1, 2, 3), x25, (4, 1, 5, 2), (0, 4, 3, 5))
    x27 = np.zeros((nocc, nocc, nocc, nocc), dtype=types[float])
    x27 += einsum(v.xoo, (0, 1, 2), x5, (3, 4, 0), (3, 1, 2, 4))
    x28 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x28 += einsum(t2, (0, 1, 2, 3), x27, (4, 1, 5, 0), (4, 5, 3, 2))
    x29 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x29 += einsum(v.xvv, (0, 1, 2), x5, (3, 4, 0), (3, 4, 1, 2))
    x30 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x30 += einsum(t2, (0, 1, 2, 3), x29, (4, 1, 5, 3), (4, 0, 2, 5))
    x31 = np.zeros((nocc, nvir, naux), dtype=types[float])
    x31 += einsum(v.xov, (0, 1, 2), (1, 2, 0))
    x31 += einsum(x2, (0, 1, 2), (0, 1, 2)) * -1.0
    x31 += einsum(x13, (0, 1, 2), (0, 1, 2))
    x32 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x32 += einsum(x23, (0, 1, 2), x31, (3, 4, 2), (3, 0, 4, 1))
    del x31
    x33 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x33 += einsum(v.xoo, (0, 1, 2), v.xov, (0, 3, 4), (1, 2, 3, 4))
    x34 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x34 += einsum(t2, (0, 1, 2, 3), x33, (4, 5, 1, 2), (0, 5, 4, 3))
    x35 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x35 += einsum(t1, (0, 1), x27, (2, 3, 4, 0), (2, 3, 4, 1))
    del x27
    x36 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x36 += einsum(v.xov, (0, 1, 2), x5, (3, 4, 0), (3, 1, 4, 2))
    x37 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x37 += einsum(t2, (0, 1, 2, 3), x36, (4, 5, 1, 2), (4, 0, 5, 3))
    x38 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x38 += einsum(x33, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    x38 += einsum(x33, (0, 1, 2, 3), (2, 1, 0, 3)) * 2.0
    x39 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x39 += einsum(t2, (0, 1, 2, 3), x38, (1, 4, 5, 3), (4, 5, 0, 2))
    del x38
    x40 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x40 += einsum(x10, (0, 1), t2, (2, 3, 1, 4), (0, 2, 3, 4)) * 2.0
    del x10
    x41 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x41 += einsum(x34, (0, 1, 2, 3), (1, 0, 2, 3))
    del x34
    x41 += einsum(x35, (0, 1, 2, 3), (1, 0, 2, 3))
    del x35
    x41 += einsum(x37, (0, 1, 2, 3), (2, 0, 1, 3))
    del x37
    x41 += einsum(x39, (0, 1, 2, 3), (1, 2, 0, 3)) * -1.0
    del x39
    x41 += einsum(x40, (0, 1, 2, 3), (0, 2, 1, 3)) * -1.0
    del x40
    x42 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x42 += einsum(t1, (0, 1), x41, (0, 2, 3, 4), (2, 3, 4, 1))
    del x41
    x43 = np.zeros((nocc, nvir), dtype=types[float])
    x43 += einsum(f.ov, (0, 1), (0, 1))
    x43 += einsum(x1, (0, 1), (0, 1)) * 2.0
    del x1
    x43 += einsum(x9, (0, 1), (0, 1)) * -1.0
    del x9
    x44 = np.zeros((nocc, nocc), dtype=types[float])
    x44 += einsum(t1, (0, 1), x43, (2, 1), (2, 0)) * 0.5
    del x43
    x45 = np.zeros((nocc, nocc), dtype=types[float])
    x45 += einsum(f.oo, (0, 1), (0, 1)) * 0.5
    x45 += einsum(x44, (0, 1), (1, 0))
    del x44
    x46 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x46 += einsum(x45, (0, 1), t2, (2, 1, 3, 4), (0, 2, 4, 3)) * 2.0
    del x45
    x47 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x47 += einsum(x24, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x24
    x47 += einsum(x26, (0, 1, 2, 3), (0, 1, 2, 3))
    del x26
    x47 += einsum(x28, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x28
    x47 += einsum(x30, (0, 1, 2, 3), (0, 1, 2, 3))
    del x30
    x47 += einsum(x32, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    del x32
    x47 += einsum(x42, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    del x42
    x47 += einsum(x46, (0, 1, 2, 3), (0, 1, 3, 2))
    del x46
    t2new += einsum(x47, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    t2new += einsum(x47, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    del x47
    x48 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x48 += einsum(t2, (0, 1, 2, 3), x29, (4, 1, 5, 2), (4, 0, 3, 5))
    del x29
    x49 = np.zeros((nocc, nvir, naux), dtype=types[float])
    x49 += einsum(v.xov, (0, 1, 2), (1, 2, 0))
    x49 += einsum(x19, (0, 1, 2), (0, 1, 2)) * -1.0
    del x19
    x50 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x50 += einsum(v.xov, (0, 1, 2), x49, (3, 4, 0), (3, 1, 4, 2)) * 2.0
    del x49
    x51 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x51 += einsum(x25, (0, 1, 2, 3), (1, 0, 3, 2))
    del x25
    x51 += einsum(x20, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x20
    x51 += einsum(x50, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x50
    x52 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x52 += einsum(t2, (0, 1, 2, 3), x51, (4, 1, 5, 3), (4, 0, 5, 2))
    del x51
    x53 = np.zeros((nvir, nvir), dtype=types[float])
    x53 += einsum(x0, (0,), v.xvv, (0, 1, 2), (1, 2))
    del x0
    x54 = np.zeros((nocc, nvir, naux), dtype=types[float])
    x54 += einsum(x23, (0, 1, 2), (0, 1, 2))
    x54 += einsum(x13, (0, 1, 2), (0, 1, 2))
    del x13
    x55 = np.zeros((nvir, nvir), dtype=types[float])
    x55 += einsum(v.xov, (0, 1, 2), x54, (1, 3, 0), (3, 2))
    del x54
    x56 = np.zeros((nvir, nvir), dtype=types[float])
    x56 += einsum(x53, (0, 1), (1, 0)) * -2.0
    del x53
    x56 += einsum(x55, (0, 1), (1, 0))
    del x55
    x57 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x57 += einsum(x56, (0, 1), t2, (2, 3, 0, 4), (2, 3, 1, 4))
    del x56
    x58 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x58 += einsum(t2, (0, 1, 2, 3), (0, 1, 2, 3))
    x58 += einsum(t1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    x59 = np.zeros((nocc, nvir, naux), dtype=types[float])
    x59 += einsum(v.xov, (0, 1, 2), x58, (1, 3, 4, 2), (3, 4, 0))
    x60 = np.zeros((nocc, nvir, naux), dtype=types[float])
    x60 += einsum(x2, (0, 1, 2), (0, 1, 2))
    x60 += einsum(x59, (0, 1, 2), (0, 1, 2))
    del x59
    x61 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x61 += einsum(v.xov, (0, 1, 2), x60, (3, 4, 0), (3, 1, 4, 2))
    del x60
    x62 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x62 += einsum(t2, (0, 1, 2, 3), x33, (4, 1, 5, 2), (0, 4, 5, 3))
    del x33
    x63 = np.zeros((nocc, nvir, nvir, nvir), dtype=types[float])
    x63 += einsum(v.xov, (0, 1, 2), v.xvv, (0, 3, 4), (1, 2, 3, 4))
    x64 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x64 += einsum(t2, (0, 1, 2, 3), x63, (4, 2, 5, 3), (0, 1, 4, 5))
    del x63
    x65 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x65 += einsum(x23, (0, 1, 2), x5, (3, 4, 2), (3, 0, 4, 1))
    del x23
    x66 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x66 += einsum(t2, (0, 1, 2, 3), x36, (4, 1, 5, 2), (4, 0, 5, 3))
    x67 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x67 += einsum(x36, (0, 1, 2, 3), (0, 1, 2, 3)) * -0.5
    x67 += einsum(x36, (0, 1, 2, 3), (0, 2, 1, 3))
    del x36
    x68 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x68 += einsum(t2, (0, 1, 2, 3), x67, (4, 5, 1, 3), (4, 5, 0, 2)) * 2.0
    del x67
    x69 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x69 += einsum(x62, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x62
    x69 += einsum(x64, (0, 1, 2, 3), (0, 1, 2, 3))
    del x64
    x69 += einsum(x65, (0, 1, 2, 3), (0, 1, 2, 3))
    del x65
    x69 += einsum(x66, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x66
    x69 += einsum(x68, (0, 1, 2, 3), (0, 2, 1, 3))
    del x68
    x70 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x70 += einsum(t1, (0, 1), x69, (2, 3, 0, 4), (2, 3, 4, 1))
    del x69
    x71 = np.zeros((nocc, nvir, naux), dtype=types[float])
    x71 += einsum(v.xov, (0, 1, 2), x8, (1, 3, 2, 4), (3, 4, 0))
    del x8
    x72 = np.zeros((nocc, nvir, naux), dtype=types[float])
    x72 += einsum(x2, (0, 1, 2), (0, 1, 2))
    del x2
    x72 += einsum(x71, (0, 1, 2), (0, 1, 2)) * -1.0
    del x71
    x73 = np.zeros((nocc, nocc), dtype=types[float])
    x73 += einsum(v.xov, (0, 1, 2), x72, (3, 2, 0), (3, 1)) * 0.5
    del x72
    x74 = np.zeros((nocc, nocc), dtype=types[float])
    x74 += einsum(x11, (0, 1), (1, 0))
    del x11
    x74 += einsum(x73, (0, 1), (1, 0)) * -1.0
    del x73
    x75 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x75 += einsum(x74, (0, 1), t2, (2, 0, 3, 4), (1, 2, 4, 3)) * 2.0
    del x74
    x76 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x76 += einsum(x48, (0, 1, 2, 3), (0, 1, 2, 3))
    del x48
    x76 += einsum(x52, (0, 1, 2, 3), (1, 0, 3, 2))
    del x52
    x76 += einsum(x57, (0, 1, 2, 3), (1, 0, 3, 2))
    del x57
    x76 += einsum(x61, (0, 1, 2, 3), (0, 1, 2, 3))
    del x61
    x76 += einsum(x70, (0, 1, 2, 3), (0, 1, 3, 2))
    del x70
    x76 += einsum(x75, (0, 1, 2, 3), (1, 0, 3, 2))
    del x75
    t2new += einsum(x76, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    t2new += einsum(x76, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    del x76
    x77 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x77 += einsum(x17, (0, 1, 2, 3), (1, 0, 2, 3)) * -0.5
    x77 += einsum(x17, (0, 1, 2, 3), (1, 0, 3, 2))
    del x17
    x78 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x78 += einsum(t2, (0, 1, 2, 3), x77, (1, 4, 3, 5), (0, 4, 2, 5)) * 2.0
    del x77
    t2new += einsum(t2, (0, 1, 2, 3), x78, (4, 1, 5, 3), (4, 0, 5, 2)) * 2.0
    del x78
    x79 = np.zeros((nocc, nocc, nocc, nocc), dtype=types[float])
    x79 += einsum(v.xoo, (0, 1, 2), v.xoo, (0, 3, 4), (1, 3, 4, 2))
    x79 += einsum(x5, (0, 1, 2), x5, (3, 4, 2), (4, 0, 1, 3))
    del x5
    t2new += einsum(x58, (0, 1, 2, 3), x79, (0, 4, 1, 5), (4, 5, 3, 2))
    del x58, x79

    return {"t1new": t1new, "t2new": t2new}

def update_lams(f=None, v=None, nocc=None, nvir=None, naux=None, t1=None, t2=None, l1=None, l2=None, **kwargs):
    # L amplitudes
    l1new = np.zeros((nvir, nocc), dtype=types[float])
    l1new += einsum(f.ov, (0, 1), (1, 0))
    x0 = np.zeros((naux,), dtype=types[float])
    x0 += einsum(t1, (0, 1), v.xov, (2, 0, 1), (2,))
    x1 = np.zeros((nocc, nvir), dtype=types[float])
    x1 += einsum(x0, (0,), v.xov, (0, 1, 2), (1, 2))
    x2 = np.zeros((nocc, nocc), dtype=types[float])
    x2 += einsum(l1, (0, 1), t1, (2, 0), (1, 2))
    l1new += einsum(x1, (0, 1), x2, (2, 0), (1, 2)) * -2.0
    x3 = np.zeros((nocc, nvir, naux), dtype=types[float])
    x3 += einsum(t1, (0, 1), v.xvv, (2, 3, 1), (0, 3, 2))
    x4 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x4 += einsum(t2, (0, 1, 2, 3), (0, 1, 3, 2)) * -0.5
    x4 += einsum(t2, (0, 1, 2, 3), (0, 1, 2, 3))
    x5 = np.zeros((nocc, nvir, naux), dtype=types[float])
    x5 += einsum(v.xov, (0, 1, 2), x4, (1, 3, 2, 4), (3, 4, 0)) * 2.0
    x6 = np.zeros((nocc, nvir, naux), dtype=types[float])
    x6 += einsum(v.xov, (0, 1, 2), (1, 2, 0))
    x6 += einsum(x3, (0, 1, 2), (0, 1, 2))
    x6 += einsum(x5, (0, 1, 2), (0, 1, 2))
    x7 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x7 += einsum(l2, (0, 1, 2, 3), (3, 2, 0, 1)) * -1.0
    x7 += einsum(l2, (0, 1, 2, 3), (2, 3, 0, 1)) * 2.0
    x8 = np.zeros((nocc, nocc, naux), dtype=types[float])
    x8 += einsum(t1, (0, 1), v.xov, (2, 3, 1), (0, 3, 2))
    x9 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x9 += einsum(t1, (0, 1), l2, (2, 1, 3, 4), (3, 4, 0, 2))
    x10 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x10 += einsum(x9, (0, 1, 2, 3), (0, 1, 2, 3))
    x10 += einsum(x9, (0, 1, 2, 3), (1, 0, 2, 3)) * -0.5
    x11 = np.zeros((nvir, nvir), dtype=types[float])
    x11 += einsum(l2, (0, 1, 2, 3), x4, (3, 2, 1, 4), (0, 4))
    x12 = np.zeros((nocc, nocc, naux), dtype=types[float])
    x12 += einsum(v.xoo, (0, 1, 2), (1, 2, 0))
    x12 += einsum(x8, (0, 1, 2), (0, 1, 2))
    x13 = np.zeros((nocc, nvir, naux), dtype=types[float])
    x13 += einsum(x6, (0, 1, 2), x7, (0, 3, 1, 4), (3, 4, 2)) * -0.5
    del x7
    x13 += einsum(x8, (0, 1, 2), x10, (3, 0, 1, 4), (3, 4, 2))
    x13 += einsum(v.xoo, (0, 1, 2), x10, (3, 1, 2, 4), (3, 4, 0))
    del x10
    x13 += einsum(x11, (0, 1), v.xov, (2, 3, 1), (3, 0, 2))
    x13 += einsum(l1, (0, 1), x12, (1, 2, 3), (2, 0, 3)) * 0.5
    del x12
    l1new += einsum(v.xvv, (0, 1, 2), x13, (3, 2, 0), (1, 3)) * -2.0
    del x13
    x14 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x14 += einsum(v.xoo, (0, 1, 2), x3, (3, 4, 0), (3, 1, 2, 4))
    x15 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x15 += einsum(f.ov, (0, 1), t2, (2, 3, 4, 1), (0, 2, 3, 4))
    x16 = np.zeros((nocc, nvir, nvir, nvir), dtype=types[float])
    x16 += einsum(v.xov, (0, 1, 2), v.xvv, (0, 3, 4), (1, 2, 3, 4))
    x17 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x17 += einsum(t2, (0, 1, 2, 3), x16, (4, 2, 5, 3), (0, 1, 4, 5))
    x18 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x18 += einsum(x3, (0, 1, 2), x8, (3, 4, 2), (3, 0, 4, 1))
    x19 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x19 += einsum(v.xov, (0, 1, 2), v.xov, (0, 3, 4), (1, 3, 2, 4))
    l2new = np.zeros((nvir, nvir, nocc, nocc), dtype=types[float])
    l2new += einsum(x19, (0, 1, 2, 3), (3, 2, 1, 0))
    x20 = np.zeros((nocc, nocc, nocc, nocc), dtype=types[float])
    x20 += einsum(t2, (0, 1, 2, 3), x19, (4, 5, 3, 2), (0, 1, 5, 4))
    x21 = np.zeros((nocc, nocc, nocc, nocc), dtype=types[float])
    x21 += einsum(x8, (0, 1, 2), x8, (3, 4, 2), (0, 3, 1, 4))
    x22 = np.zeros((nocc, nocc, nocc, nocc), dtype=types[float])
    x22 += einsum(x20, (0, 1, 2, 3), (0, 1, 2, 3))
    x22 += einsum(x21, (0, 1, 2, 3), (0, 1, 2, 3))
    x23 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x23 += einsum(t1, (0, 1), x22, (2, 3, 4, 0), (2, 3, 4, 1))
    del x22
    x24 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x24 += einsum(x17, (0, 1, 2, 3), (0, 1, 2, 3))
    del x17
    x24 += einsum(x18, (0, 1, 2, 3), (0, 1, 2, 3))
    del x18
    x24 += einsum(x23, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x23
    x25 = np.zeros((nocc, nvir), dtype=types[float])
    x25 += einsum(v.xov, (0, 1, 2), x8, (1, 3, 0), (3, 2))
    x26 = np.zeros((nocc, nvir), dtype=types[float])
    x26 += einsum(x1, (0, 1), (0, 1))
    x26 += einsum(x25, (0, 1), (0, 1)) * -0.5
    x27 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x27 += einsum(x26, (0, 1), t2, (2, 3, 1, 4), (2, 3, 0, 4))
    x28 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x28 += einsum(v.xoo, (0, 1, 2), v.xov, (0, 3, 4), (1, 2, 3, 4))
    x29 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x29 += einsum(v.xov, (0, 1, 2), x8, (3, 4, 0), (3, 1, 4, 2))
    x30 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x30 += einsum(x28, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    x30 += einsum(x28, (0, 1, 2, 3), (1, 2, 0, 3)) * 2.0
    x30 += einsum(x29, (0, 1, 2, 3), (0, 1, 2, 3)) * 2.0
    x30 += einsum(x29, (0, 1, 2, 3), (0, 2, 1, 3)) * -1.0
    x31 = np.zeros((nocc, nocc, naux), dtype=types[float])
    x31 += einsum(v.xoo, (0, 1, 2), (1, 2, 0))
    x31 += einsum(x8, (0, 1, 2), (1, 0, 2))
    x32 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x32 += einsum(v.xov, (0, 1, 2), x31, (3, 4, 0), (1, 3, 4, 2))
    x33 = np.zeros((nocc, nocc, nocc, nocc), dtype=types[float])
    x33 += einsum(v.xoo, (0, 1, 2), v.xoo, (0, 3, 4), (1, 3, 4, 2))
    x34 = np.zeros((nocc, nocc, nocc, nocc), dtype=types[float])
    x34 += einsum(v.xoo, (0, 1, 2), x8, (3, 4, 0), (3, 1, 2, 4))
    x35 = np.zeros((nocc, nocc, nocc, nocc), dtype=types[float])
    x35 += einsum(x33, (0, 1, 2, 3), (3, 2, 1, 0))
    x35 += einsum(x34, (0, 1, 2, 3), (1, 0, 3, 2))
    x35 += einsum(x34, (0, 1, 2, 3), (3, 0, 2, 1)) * -0.5
    x36 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x36 += einsum(x14, (0, 1, 2, 3), (0, 2, 1, 3)) * 0.5
    x36 += einsum(x15, (0, 1, 2, 3), (1, 0, 2, 3)) * 0.5
    x36 += einsum(x15, (0, 1, 2, 3), (2, 0, 1, 3)) * -1.0
    del x15
    x36 += einsum(x24, (0, 1, 2, 3), (0, 2, 1, 3)) * -1.0
    x36 += einsum(x24, (0, 1, 2, 3), (1, 2, 0, 3)) * 0.5
    del x24
    x36 += einsum(x27, (0, 1, 2, 3), (1, 2, 0, 3))
    x36 += einsum(x27, (0, 1, 2, 3), (0, 2, 1, 3)) * -2.0
    del x27
    x36 += einsum(x30, (0, 1, 2, 3), x4, (1, 4, 3, 5), (0, 2, 4, 5)) * -1.0
    del x30
    x36 += einsum(x32, (0, 1, 2, 3), (2, 1, 0, 3)) * -1.0
    x36 += einsum(t1, (0, 1), x35, (0, 2, 3, 4), (2, 3, 4, 1))
    del x35
    l1new += einsum(l2, (0, 1, 2, 3), x36, (2, 4, 3, 1), (0, 4)) * 2.0
    del x36
    x37 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x37 += einsum(t2, (0, 1, 2, 3), (0, 1, 3, 2)) * 2.0
    x37 += einsum(t2, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    x38 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x38 += einsum(l2, (0, 1, 2, 3), x4, (3, 4, 1, 5), (2, 4, 0, 5))
    x38 += einsum(l2, (0, 1, 2, 3), x37, (2, 4, 1, 5), (3, 4, 0, 5)) * 0.5
    del x37
    x39 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x39 += einsum(l1, (0, 1), t2, (2, 3, 4, 0), (1, 2, 3, 4))
    x40 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x40 += einsum(t2, (0, 1, 2, 3), x9, (4, 1, 5, 2), (4, 5, 0, 3))
    x41 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x41 += einsum(x39, (0, 1, 2, 3), (0, 1, 2, 3)) * 2.0
    del x39
    x41 += einsum(x40, (0, 1, 2, 3), (0, 1, 2, 3)) * -2.0
    del x40
    x42 = np.zeros((nocc, nocc, nocc, nocc), dtype=types[float])
    x42 += einsum(l2, (0, 1, 2, 3), t2, (4, 5, 0, 1), (2, 3, 4, 5))
    x43 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x43 += einsum(t1, (0, 1), x42, (2, 0, 3, 4), (2, 3, 4, 1))
    x44 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x44 += einsum(t2, (0, 1, 2, 3), x9, (4, 1, 5, 3), (4, 5, 0, 2))
    x45 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x45 += einsum(t2, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    x45 += einsum(t2, (0, 1, 2, 3), (0, 1, 2, 3)) * 2.0
    x46 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x46 += einsum(x45, (0, 1, 2, 3), x9, (0, 4, 5, 2), (4, 5, 1, 3))
    x47 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x47 += einsum(x43, (0, 1, 2, 3), (0, 1, 2, 3))
    del x43
    x47 += einsum(x44, (0, 1, 2, 3), (0, 1, 2, 3))
    del x44
    x47 += einsum(x46, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x46
    x48 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x48 += einsum(x41, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    x48 += einsum(x41, (0, 1, 2, 3), (0, 2, 1, 3)) * 0.5
    del x41
    x48 += einsum(x9, (0, 1, 2, 3), (0, 1, 2, 3))
    x48 += einsum(x9, (0, 1, 2, 3), (1, 0, 2, 3)) * -2.0
    x48 += einsum(x47, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    x48 += einsum(x47, (0, 1, 2, 3), (0, 2, 1, 3)) * 2.0
    del x47
    x49 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x49 += einsum(x9, (0, 1, 2, 3), (0, 1, 2, 3)) * 2.0
    x49 += einsum(x9, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    x50 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x50 += einsum(t2, (0, 1, 2, 3), (0, 1, 3, 2))
    x50 += einsum(t2, (0, 1, 2, 3), (0, 1, 2, 3)) * -0.5
    x51 = np.zeros((nocc, nocc), dtype=types[float])
    x51 += einsum(l2, (0, 1, 2, 3), x50, (3, 4, 0, 1), (2, 4)) * 2.0
    x52 = np.zeros((nocc, nocc), dtype=types[float])
    x52 += einsum(x2, (0, 1), (0, 1))
    x52 += einsum(x51, (0, 1), (0, 1))
    l1new += einsum(f.ov, (0, 1), x52, (2, 0), (1, 2)) * -1.0
    x53 = np.zeros((nocc, nvir), dtype=types[float])
    x53 += einsum(t1, (0, 1), (0, 1)) * -1.0
    x53 += einsum(x4, (0, 1, 2, 3), x9, (0, 1, 4, 2), (4, 3)) * 2.0
    x53 += einsum(l1, (0, 1), x45, (1, 2, 0, 3), (2, 3)) * -1.0
    x53 += einsum(t1, (0, 1), x52, (0, 2), (2, 1))
    x54 = np.zeros((nocc, nocc, nocc, nocc), dtype=types[float])
    x54 += einsum(t1, (0, 1), x9, (2, 3, 4, 1), (3, 2, 4, 0))
    x55 = np.zeros((nocc, nocc, nocc, nocc), dtype=types[float])
    x55 += einsum(x42, (0, 1, 2, 3), (1, 0, 2, 3)) * -0.5
    x55 += einsum(x42, (0, 1, 2, 3), (1, 0, 3, 2))
    x55 += einsum(x54, (0, 1, 2, 3), (0, 1, 2, 3))
    x55 += einsum(x54, (0, 1, 2, 3), (0, 1, 3, 2)) * -0.5
    x56 = np.zeros((nocc, nocc, nocc, nocc), dtype=types[float])
    x56 += einsum(x54, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    x56 += einsum(x54, (0, 1, 2, 3), (0, 1, 3, 2)) * 2.0
    x57 = np.zeros((nocc, nvir, naux), dtype=types[float])
    x57 += einsum(l1, (0, 1), v.xvv, (2, 3, 0), (1, 3, 2))
    x58 = np.zeros((nocc, nvir, naux), dtype=types[float])
    x58 += einsum(x52, (0, 1), v.xov, (2, 1, 3), (0, 3, 2))
    x59 = np.zeros((nocc, nvir, naux), dtype=types[float])
    x59 += einsum(x57, (0, 1, 2), (0, 1, 2)) * -1.0
    del x57
    x59 += einsum(x58, (0, 1, 2), (0, 1, 2))
    del x58
    x60 = np.zeros((nocc, nocc), dtype=types[float])
    x60 += einsum(l2, (0, 1, 2, 3), x50, (3, 4, 0, 1), (2, 4))
    del x50
    x61 = np.zeros((nocc, nocc), dtype=types[float])
    x61 += einsum(x2, (0, 1), (0, 1)) * 0.5
    del x2
    x61 += einsum(x60, (0, 1), (0, 1))
    del x60
    x62 = np.zeros((nocc, nocc, naux), dtype=types[float])
    x62 += einsum(v.xvv, (0, 1, 2), x38, (3, 4, 1, 2), (4, 3, 0)) * -2.0
    del x38
    x62 += einsum(v.xov, (0, 1, 2), x48, (3, 1, 4, 2), (4, 3, 0))
    del x48
    x62 += einsum(x3, (0, 1, 2), x49, (0, 3, 4, 1), (4, 3, 2)) * -1.0
    x62 += einsum(x53, (0, 1), v.xov, (2, 3, 1), (0, 3, 2))
    del x53
    x62 += einsum(v.xoo, (0, 1, 2), x55, (1, 3, 2, 4), (4, 3, 0)) * 2.0
    del x55
    x62 += einsum(x8, (0, 1, 2), x56, (0, 3, 4, 1), (4, 3, 2))
    del x8, x56
    x62 += einsum(t1, (0, 1), x59, (2, 1, 3), (0, 2, 3))
    x62 += einsum(x61, (0, 1), v.xoo, (2, 3, 0), (1, 3, 2)) * 2.0
    x62 += einsum(x0, (0,), x51, (1, 2), (2, 1, 0)) * -2.0
    del x51
    l1new += einsum(v.xov, (0, 1, 2), x62, (1, 3, 0), (2, 3))
    del x62
    x63 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x63 += einsum(x28, (0, 1, 2, 3), (1, 0, 2, 3)) * -0.5
    x63 += einsum(x28, (0, 1, 2, 3), (1, 2, 0, 3))
    x63 += einsum(x29, (0, 1, 2, 3), (0, 1, 2, 3))
    x63 += einsum(x29, (0, 1, 2, 3), (0, 2, 1, 3)) * -0.5
    x64 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x64 += einsum(x28, (0, 1, 2, 3), (1, 0, 2, 3)) * 2.0
    x64 += einsum(x28, (0, 1, 2, 3), (1, 2, 0, 3)) * -1.0
    x64 += einsum(x29, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    x64 += einsum(x29, (0, 1, 2, 3), (0, 2, 1, 3)) * 2.0
    x65 = np.zeros((nocc, nocc, nocc, nocc), dtype=types[float])
    x65 += einsum(x33, (0, 1, 2, 3), (3, 2, 1, 0))
    x65 += einsum(x34, (0, 1, 2, 3), (1, 0, 3, 2))
    x65 += einsum(x34, (0, 1, 2, 3), (3, 0, 2, 1)) * -2.0
    x66 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x66 += einsum(x14, (0, 1, 2, 3), (0, 2, 1, 3)) * -2.0
    del x14
    x66 += einsum(t2, (0, 1, 2, 3), x63, (4, 1, 5, 3), (4, 5, 0, 2)) * 2.0
    del x63
    x66 += einsum(t2, (0, 1, 2, 3), x64, (4, 1, 5, 2), (4, 5, 0, 3))
    del x64
    x66 += einsum(x32, (0, 1, 2, 3), (2, 1, 0, 3))
    del x32
    x66 += einsum(t1, (0, 1), x65, (0, 2, 3, 4), (2, 3, 4, 1)) * -1.0
    del x65
    l1new += einsum(l2, (0, 1, 2, 3), x66, (3, 4, 2, 1), (0, 4))
    del x66
    x67 = np.zeros((nvir, nvir), dtype=types[float])
    x67 += einsum(l1, (0, 1), t1, (1, 2), (0, 2))
    x67 += einsum(l2, (0, 1, 2, 3), x4, (3, 2, 1, 4), (4, 0)) * 2.0
    x68 = np.zeros((nocc, nvir), dtype=types[float])
    x68 += einsum(l1, (0, 1), (1, 0))
    x68 += einsum(t1, (0, 1), (0, 1))
    x68 += einsum(x45, (0, 1, 2, 3), x9, (0, 1, 4, 2), (4, 3)) * -1.0
    x68 += einsum(l1, (0, 1), x4, (1, 2, 0, 3), (2, 3)) * 2.0
    x68 += einsum(t1, (0, 1), x61, (0, 2), (2, 1)) * -2.0
    del x61
    x69 = np.zeros((naux,), dtype=types[float])
    x69 += einsum(x67, (0, 1), v.xvv, (2, 0, 1), (2,))
    del x67
    x69 += einsum(x68, (0, 1), v.xov, (2, 0, 1), (2,))
    del x68
    x69 += einsum(x52, (0, 1), v.xoo, (2, 1, 0), (2,)) * -1.0
    del x52
    l1new += einsum(x69, (0,), v.xov, (0, 1, 2), (2, 1)) * 2.0
    del x69
    x70 = np.zeros((nocc, nocc), dtype=types[float])
    x70 += einsum(x0, (0,), v.xoo, (0, 1, 2), (1, 2))
    x71 = np.zeros((nocc, nvir, naux), dtype=types[float])
    x71 += einsum(t1, (0, 1), v.xoo, (2, 3, 0), (3, 1, 2))
    x72 = np.zeros((nocc, nvir, naux), dtype=types[float])
    x72 += einsum(v.xov, (0, 1, 2), x45, (1, 3, 2, 4), (3, 4, 0))
    del x45
    x73 = np.zeros((nocc, nvir, naux), dtype=types[float])
    x73 += einsum(x71, (0, 1, 2), (0, 1, 2))
    del x71
    x73 += einsum(x72, (0, 1, 2), (0, 1, 2)) * -1.0
    del x72
    x74 = np.zeros((nocc, nvir), dtype=types[float])
    x74 += einsum(f.ov, (0, 1), (0, 1))
    x74 += einsum(x1, (0, 1), (0, 1)) * 2.0
    x74 += einsum(x25, (0, 1), (0, 1)) * -1.0
    x75 = np.zeros((nocc, nocc), dtype=types[float])
    x75 += einsum(f.oo, (0, 1), (0, 1))
    x75 += einsum(x70, (0, 1), (1, 0)) * 2.0
    x75 += einsum(v.xov, (0, 1, 2), x73, (3, 2, 0), (3, 1)) * -1.0
    x75 += einsum(t1, (0, 1), x74, (2, 1), (0, 2))
    del x74
    l1new += einsum(l1, (0, 1), x75, (1, 2), (0, 2)) * -1.0
    del x75
    x76 = np.zeros((nvir, nvir), dtype=types[float])
    x76 += einsum(x0, (0,), v.xvv, (0, 1, 2), (1, 2))
    del x0
    x77 = np.zeros((nvir, nvir), dtype=types[float])
    x77 += einsum(f.vv, (0, 1), (0, 1))
    x77 += einsum(x76, (0, 1), (1, 0)) * 2.0
    l1new += einsum(l1, (0, 1), x77, (0, 2), (2, 1))
    del x77
    x78 = np.zeros((nvir, nvir, nvir, nvir), dtype=types[float])
    x78 += einsum(v.xvv, (0, 1, 2), v.xvv, (0, 3, 4), (1, 3, 4, 2))
    l2new += einsum(l2, (0, 1, 2, 3), x78, (4, 5, 0, 1), (4, 5, 3, 2))
    del x78
    x79 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x79 += einsum(l1, (0, 1), x28, (2, 1, 3, 4), (2, 3, 0, 4))
    x80 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x80 += einsum(x28, (0, 1, 2, 3), x9, (4, 1, 2, 5), (4, 0, 5, 3))
    x81 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x81 += einsum(x16, (0, 1, 2, 3), x9, (4, 5, 0, 2), (5, 4, 1, 3))
    del x16
    x82 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x82 += einsum(l2, (0, 1, 2, 3), t2, (4, 2, 5, 1), (3, 4, 0, 5))
    x83 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x83 += einsum(x19, (0, 1, 2, 3), x82, (4, 1, 5, 2), (4, 0, 5, 3))
    del x82
    x84 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x84 += einsum(x29, (0, 1, 2, 3), x9, (4, 0, 1, 5), (4, 2, 5, 3))
    x85 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x85 += einsum(x19, (0, 1, 2, 3), x4, (0, 4, 3, 5), (1, 4, 2, 5)) * 2.0
    del x4
    x86 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x86 += einsum(v.xvv, (0, 1, 2), x31, (3, 4, 0), (3, 4, 1, 2))
    del x31
    x87 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x87 += einsum(v.xov, (0, 1, 2), x5, (3, 4, 0), (1, 3, 2, 4)) * 2.0
    x88 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x88 += einsum(x85, (0, 1, 2, 3), (1, 0, 3, 2))
    del x85
    x88 += einsum(x86, (0, 1, 2, 3), (1, 0, 3, 2))
    x88 += einsum(x87, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    del x87
    x89 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x89 += einsum(l2, (0, 1, 2, 3), x88, (3, 4, 1, 5), (2, 4, 0, 5))
    del x88
    x90 = np.zeros((nocc, nvir, naux), dtype=types[float])
    x90 += einsum(x6, (0, 1, 2), l2, (3, 1, 0, 4), (4, 3, 2))
    del x6
    x91 = np.zeros((nocc, nvir, naux), dtype=types[float])
    x91 += einsum(v.xov, (0, 1, 2), (1, 2, 0))
    x91 += einsum(x3, (0, 1, 2), (0, 1, 2))
    x92 = np.zeros((nocc, nvir, naux), dtype=types[float])
    x92 += einsum(x91, (0, 1, 2), l2, (3, 1, 4, 0), (4, 3, 2)) * 2.0
    del x91
    x93 = np.zeros((nocc, nvir, naux), dtype=types[float])
    x93 += einsum(x90, (0, 1, 2), (0, 1, 2)) * -1.0
    del x90
    x93 += einsum(x92, (0, 1, 2), (0, 1, 2))
    del x92
    x94 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x94 += einsum(v.xov, (0, 1, 2), x93, (3, 4, 0), (1, 3, 2, 4))
    del x93
    x95 = np.zeros((nocc, nvir, naux), dtype=types[float])
    x95 += einsum(x3, (0, 1, 2), (0, 1, 2))
    del x3
    x95 += einsum(x5, (0, 1, 2), (0, 1, 2))
    del x5
    x96 = np.zeros((nvir, nvir), dtype=types[float])
    x96 += einsum(v.xov, (0, 1, 2), x95, (1, 3, 0), (2, 3))
    del x95
    x97 = np.zeros((nvir, nvir), dtype=types[float])
    x97 += einsum(x76, (0, 1), (1, 0)) * -2.0
    del x76
    x97 += einsum(x96, (0, 1), (0, 1))
    del x96
    x98 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x98 += einsum(x97, (0, 1), l2, (2, 1, 3, 4), (4, 3, 2, 0))
    del x97
    x99 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x99 += einsum(x9, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    x99 += einsum(x9, (0, 1, 2, 3), (1, 0, 2, 3)) * 2.0
    x100 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x100 += einsum(x28, (0, 1, 2, 3), x99, (0, 4, 1, 5), (2, 4, 3, 5))
    del x99
    x101 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x101 += einsum(x29, (0, 1, 2, 3), x49, (4, 0, 2, 5), (1, 4, 3, 5))
    del x49
    x102 = np.zeros((nocc, nocc), dtype=types[float])
    x102 += einsum(v.xov, (0, 1, 2), x73, (3, 2, 0), (1, 3)) * 0.5
    del x73
    x103 = np.zeros((nocc, nocc), dtype=types[float])
    x103 += einsum(t1, (0, 1), x26, (2, 1), (0, 2))
    x104 = np.zeros((nocc, nocc), dtype=types[float])
    x104 += einsum(x70, (0, 1), (1, 0))
    del x70
    x104 += einsum(x102, (0, 1), (1, 0)) * -1.0
    del x102
    x104 += einsum(x103, (0, 1), (0, 1))
    del x103
    x105 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x105 += einsum(x104, (0, 1), l2, (2, 3, 0, 4), (4, 1, 2, 3)) * 2.0
    del x104
    x106 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x106 += einsum(x26, (0, 1), x9, (2, 3, 0, 4), (2, 3, 4, 1)) * 2.0
    del x26
    x107 = np.zeros((nocc, nvir), dtype=types[float])
    x107 += einsum(x1, (0, 1), (0, 1)) * 2.0
    del x1
    x107 += einsum(x25, (0, 1), (0, 1)) * -1.0
    del x25
    x108 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x108 += einsum(f.ov, (0, 1), l1, (2, 3), (0, 3, 1, 2)) * -1.0
    x108 += einsum(x79, (0, 1, 2, 3), (0, 1, 2, 3))
    del x79
    x108 += einsum(x80, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x80
    x108 += einsum(x81, (0, 1, 2, 3), (0, 1, 2, 3))
    del x81
    x108 += einsum(x83, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x83
    x108 += einsum(x84, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x84
    x108 += einsum(x89, (0, 1, 2, 3), (0, 1, 2, 3))
    del x89
    x108 += einsum(x94, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    del x94
    x108 += einsum(x98, (0, 1, 2, 3), (1, 0, 2, 3))
    del x98
    x108 += einsum(x100, (0, 1, 2, 3), (1, 0, 3, 2))
    del x100
    x108 += einsum(x101, (0, 1, 2, 3), (1, 0, 3, 2))
    del x101
    x108 += einsum(x105, (0, 1, 2, 3), (0, 1, 3, 2))
    del x105
    x108 += einsum(x106, (0, 1, 2, 3), (0, 1, 2, 3))
    del x106
    x108 += einsum(l1, (0, 1), x107, (2, 3), (1, 2, 0, 3)) * -1.0
    del x107
    l2new += einsum(x108, (0, 1, 2, 3), (2, 3, 0, 1)) * -1.0
    l2new += einsum(x108, (0, 1, 2, 3), (3, 2, 1, 0)) * -1.0
    del x108
    x109 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x109 += einsum(f.vv, (0, 1), l2, (2, 1, 3, 4), (3, 4, 0, 2))
    x110 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x110 += einsum(f.ov, (0, 1), x9, (2, 3, 0, 4), (2, 3, 1, 4))
    x111 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x111 += einsum(l1, (0, 1), x29, (1, 2, 3, 4), (2, 3, 0, 4))
    x112 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x112 += einsum(x28, (0, 1, 2, 3), x9, (1, 4, 2, 5), (4, 0, 5, 3))
    del x28
    x113 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x113 += einsum(l2, (0, 1, 2, 3), x34, (2, 4, 3, 5), (4, 5, 0, 1))
    del x34
    x114 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x114 += einsum(x29, (0, 1, 2, 3), x9, (0, 4, 1, 5), (4, 2, 5, 3))
    del x9, x29
    x115 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x115 += einsum(t2, (0, 1, 2, 3), x19, (4, 1, 2, 5), (0, 4, 3, 5))
    x116 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x116 += einsum(x115, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x115
    x116 += einsum(x86, (0, 1, 2, 3), (1, 0, 3, 2))
    del x86
    x117 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x117 += einsum(l2, (0, 1, 2, 3), x116, (2, 4, 1, 5), (3, 4, 0, 5))
    del x116
    x118 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x118 += einsum(v.xov, (0, 1, 2), x59, (3, 4, 0), (1, 3, 2, 4))
    del x59
    x119 = np.zeros((nocc, nvir, naux), dtype=types[float])
    x119 += einsum(x11, (0, 1), v.xov, (2, 3, 1), (3, 0, 2)) * 2.0
    del x11
    x120 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x120 += einsum(v.xov, (0, 1, 2), x119, (3, 4, 0), (1, 3, 2, 4))
    del x119
    x121 = np.zeros((nocc, nocc), dtype=types[float])
    x121 += einsum(f.ov, (0, 1), t1, (2, 1), (0, 2))
    x122 = np.zeros((nocc, nocc), dtype=types[float])
    x122 += einsum(f.oo, (0, 1), (0, 1))
    x122 += einsum(x121, (0, 1), (1, 0))
    del x121
    x123 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x123 += einsum(x122, (0, 1), l2, (2, 3, 0, 4), (4, 1, 2, 3))
    del x122
    x124 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x124 += einsum(x109, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x109
    x124 += einsum(x110, (0, 1, 2, 3), (0, 1, 2, 3))
    del x110
    x124 += einsum(x111, (0, 1, 2, 3), (0, 1, 2, 3))
    del x111
    x124 += einsum(x112, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x112
    x124 += einsum(x113, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x113
    x124 += einsum(x114, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x114
    x124 += einsum(x117, (0, 1, 2, 3), (0, 1, 2, 3))
    del x117
    x124 += einsum(x118, (0, 1, 2, 3), (1, 0, 2, 3))
    del x118
    x124 += einsum(x120, (0, 1, 2, 3), (0, 1, 3, 2))
    del x120
    x124 += einsum(x123, (0, 1, 2, 3), (1, 0, 3, 2))
    del x123
    l2new += einsum(x124, (0, 1, 2, 3), (3, 2, 0, 1)) * -1.0
    l2new += einsum(x124, (0, 1, 2, 3), (2, 3, 1, 0)) * -1.0
    del x124
    x125 = np.zeros((nocc, nocc, nocc, nocc), dtype=types[float])
    x125 += einsum(x33, (0, 1, 2, 3), (3, 2, 1, 0))
    del x33
    x125 += einsum(x20, (0, 1, 2, 3), (0, 3, 1, 2))
    del x20
    x125 += einsum(x21, (0, 1, 2, 3), (0, 3, 1, 2))
    del x21
    l2new += einsum(l2, (0, 1, 2, 3), x125, (3, 4, 2, 5), (0, 1, 4, 5))
    del x125
    x126 = np.zeros((nocc, nocc, nocc, nocc), dtype=types[float])
    x126 += einsum(x42, (0, 1, 2, 3), (1, 0, 3, 2))
    del x42
    x126 += einsum(x54, (0, 1, 2, 3), (0, 1, 2, 3))
    del x54
    l2new += einsum(x126, (0, 1, 2, 3), x19, (2, 3, 4, 5), (5, 4, 1, 0))
    del x19, x126

    return {"l1new": l1new, "l2new": l2new}

def make_rdm1_f(f=None, v=None, nocc=None, nvir=None, naux=None, t1=None, t2=None, l1=None, l2=None, **kwargs):
    delta = Namespace(oo=np.eye(nocc), vv=np.eye(nvir))

    # RDM1
    rdm1_f_oo = np.zeros((nocc, nocc), dtype=types[float])
    rdm1_f_oo += einsum(delta.oo, (0, 1), (0, 1)) * 2.0
    rdm1_f_ov = np.zeros((nocc, nvir), dtype=types[float])
    rdm1_f_ov += einsum(t1, (0, 1), (0, 1)) * 2.0
    rdm1_f_vo = np.zeros((nvir, nocc), dtype=types[float])
    rdm1_f_vo += einsum(l1, (0, 1), (0, 1)) * 2.0
    rdm1_f_vv = np.zeros((nvir, nvir), dtype=types[float])
    rdm1_f_vv += einsum(l1, (0, 1), t1, (1, 2), (0, 2)) * 2.0
    x0 = np.zeros((nocc, nocc), dtype=types[float])
    x0 += einsum(l1, (0, 1), t1, (2, 0), (1, 2))
    rdm1_f_oo += einsum(x0, (0, 1), (1, 0)) * -2.0
    x1 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x1 += einsum(t2, (0, 1, 2, 3), (0, 1, 3, 2)) * 2.0
    x1 += einsum(t2, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    rdm1_f_oo += einsum(l2, (0, 1, 2, 3), x1, (2, 4, 1, 0), (4, 3)) * -2.0
    del x1
    x2 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x2 += einsum(t1, (0, 1), l2, (2, 1, 3, 4), (3, 4, 0, 2))
    x3 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x3 += einsum(x2, (0, 1, 2, 3), (0, 1, 2, 3)) * 2.0
    x3 += einsum(x2, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    del x2
    rdm1_f_ov += einsum(t2, (0, 1, 2, 3), x3, (0, 1, 4, 2), (4, 3)) * -2.0
    del x3
    x4 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x4 += einsum(t2, (0, 1, 2, 3), (0, 1, 3, 2)) * -0.5
    x4 += einsum(t2, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm1_f_ov += einsum(l1, (0, 1), x4, (1, 2, 0, 3), (2, 3)) * 4.0
    del x4
    x5 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x5 += einsum(t2, (0, 1, 2, 3), (0, 1, 3, 2))
    x5 += einsum(t2, (0, 1, 2, 3), (0, 1, 2, 3)) * -0.5
    x6 = np.zeros((nocc, nocc), dtype=types[float])
    x6 += einsum(x0, (0, 1), (0, 1)) * 0.5
    del x0
    x6 += einsum(l2, (0, 1, 2, 3), x5, (3, 4, 0, 1), (2, 4))
    del x5
    rdm1_f_ov += einsum(t1, (0, 1), x6, (0, 2), (2, 1)) * -4.0
    del x6
    x7 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x7 += einsum(l2, (0, 1, 2, 3), (3, 2, 0, 1)) * -0.5
    x7 += einsum(l2, (0, 1, 2, 3), (2, 3, 0, 1))
    rdm1_f_vv += einsum(t2, (0, 1, 2, 3), x7, (0, 1, 2, 4), (4, 3)) * 4.0
    del x7

    rdm1_f = np.block([[rdm1_f_oo, rdm1_f_ov], [rdm1_f_vo, rdm1_f_vv]])

    return rdm1_f

def make_rdm2_f(f=None, v=None, nocc=None, nvir=None, naux=None, t1=None, t2=None, l1=None, l2=None, **kwargs):
    delta = Namespace(oo=np.eye(nocc), vv=np.eye(nvir))

    # RDM2
    rdm2_f_oooo = np.zeros((nocc, nocc, nocc, nocc), dtype=types[float])
    rdm2_f_oooo += einsum(delta.oo, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3))
    rdm2_f_oooo += einsum(delta.oo, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * -1.0
    rdm2_f_oooo += einsum(delta.oo, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3))
    rdm2_f_oooo += einsum(delta.oo, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3))
    rdm2_f_oooo += einsum(delta.oo, (0, 1), delta.oo, (2, 3), (0, 2, 1, 3))
    rdm2_f_oooo += einsum(delta.oo, (0, 1), delta.oo, (2, 3), (0, 2, 3, 1)) * -1.0
    rdm2_f_ovoo = np.zeros((nocc, nvir, nocc, nocc), dtype=types[float])
    rdm2_f_ovoo += einsum(delta.oo, (0, 1), l1, (2, 3), (0, 2, 1, 3))
    rdm2_f_ovoo += einsum(delta.oo, (0, 1), l1, (2, 3), (0, 2, 3, 1)) * -1.0
    rdm2_f_ovoo += einsum(delta.oo, (0, 1), l1, (2, 3), (0, 2, 1, 3))
    rdm2_f_ovoo += einsum(delta.oo, (0, 1), l1, (2, 3), (0, 2, 1, 3))
    rdm2_f_ovoo += einsum(delta.oo, (0, 1), l1, (2, 3), (0, 2, 1, 3))
    rdm2_f_ovoo += einsum(delta.oo, (0, 1), l1, (2, 3), (0, 2, 3, 1)) * -1.0
    rdm2_f_vooo = np.zeros((nvir, nocc, nocc, nocc), dtype=types[float])
    rdm2_f_vooo += einsum(delta.oo, (0, 1), l1, (2, 3), (2, 0, 1, 3)) * -1.0
    rdm2_f_vooo += einsum(delta.oo, (0, 1), l1, (2, 3), (2, 0, 3, 1))
    rdm2_f_vooo += einsum(delta.oo, (0, 1), l1, (2, 3), (2, 0, 3, 1))
    rdm2_f_vooo += einsum(delta.oo, (0, 1), l1, (2, 3), (2, 0, 3, 1))
    rdm2_f_vooo += einsum(delta.oo, (0, 1), l1, (2, 3), (2, 0, 1, 3)) * -1.0
    rdm2_f_vooo += einsum(delta.oo, (0, 1), l1, (2, 3), (2, 0, 3, 1))
    rdm2_f_oovv = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    rdm2_f_oovv += einsum(t2, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_oovv += einsum(t2, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_ovov = np.zeros((nocc, nvir, nocc, nvir), dtype=types[float])
    rdm2_f_ovov += einsum(l1, (0, 1), t1, (2, 3), (2, 0, 1, 3)) * -1.0
    rdm2_f_ovov += einsum(l1, (0, 1), t1, (2, 3), (2, 0, 1, 3)) * -1.0
    rdm2_f_ovvo = np.zeros((nocc, nvir, nvir, nocc), dtype=types[float])
    rdm2_f_ovvo += einsum(l1, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    rdm2_f_ovvo += einsum(l1, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    rdm2_f_ovvo += einsum(l1, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    rdm2_f_ovvo += einsum(l1, (0, 1), t1, (2, 3), (2, 0, 3, 1))
    rdm2_f_voov = np.zeros((nvir, nocc, nocc, nvir), dtype=types[float])
    rdm2_f_voov += einsum(l1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2_f_voov += einsum(l1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2_f_voov += einsum(l1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2_f_voov += einsum(l1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2_f_vovo = np.zeros((nvir, nocc, nvir, nocc), dtype=types[float])
    rdm2_f_vovo += einsum(l1, (0, 1), t1, (2, 3), (0, 2, 3, 1)) * -1.0
    rdm2_f_vovo += einsum(l1, (0, 1), t1, (2, 3), (0, 2, 3, 1)) * -1.0
    rdm2_f_vvoo = np.zeros((nvir, nvir, nocc, nocc), dtype=types[float])
    rdm2_f_vvoo += einsum(l2, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    rdm2_f_vvoo += einsum(l2, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_vvoo += einsum(l2, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_vvoo += einsum(l2, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_vvoo += einsum(l2, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    rdm2_f_vvoo += einsum(l2, (0, 1, 2, 3), (0, 1, 2, 3))
    x0 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x0 += einsum(t2, (0, 1, 2, 3), (0, 1, 3, 2))
    x0 += einsum(t2, (0, 1, 2, 3), (0, 1, 2, 3)) * -0.5
    x1 = np.zeros((nocc, nocc), dtype=types[float])
    x1 += einsum(l2, (0, 1, 2, 3), x0, (2, 4, 1, 0), (3, 4))
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x1, (2, 3), (0, 3, 1, 2)) * -2.0
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x1, (2, 3), (0, 3, 2, 1)) * 2.0
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x1, (2, 3), (3, 0, 1, 2)) * 2.0
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x1, (2, 3), (3, 0, 2, 1)) * -2.0
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x1, (2, 3), (0, 3, 1, 2)) * -2.0
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x1, (2, 3), (3, 0, 2, 1)) * -2.0
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x1, (2, 3), (0, 3, 1, 2)) * -2.0
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x1, (2, 3), (3, 0, 2, 1)) * -2.0
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x1, (2, 3), (0, 3, 1, 2)) * -2.0
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x1, (2, 3), (0, 3, 2, 1)) * 2.0
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x1, (2, 3), (3, 0, 1, 2)) * 2.0
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x1, (2, 3), (3, 0, 2, 1)) * -2.0
    x2 = np.zeros((nocc, nocc, nocc, nocc), dtype=types[float])
    x2 += einsum(l2, (0, 1, 2, 3), t2, (4, 5, 0, 1), (2, 3, 4, 5))
    rdm2_f_oooo += einsum(x2, (0, 1, 2, 3), (3, 2, 1, 0))
    rdm2_f_oooo += einsum(x2, (0, 1, 2, 3), (3, 2, 1, 0))
    x3 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x3 += einsum(t1, (0, 1), l2, (2, 1, 3, 4), (3, 4, 0, 2))
    rdm2_f_ovoo += einsum(x3, (0, 1, 2, 3), (2, 3, 0, 1))
    rdm2_f_ovoo += einsum(x3, (0, 1, 2, 3), (2, 3, 1, 0)) * -1.0
    rdm2_f_ovoo += einsum(x3, (0, 1, 2, 3), (2, 3, 1, 0)) * -1.0
    rdm2_f_ovoo += einsum(x3, (0, 1, 2, 3), (2, 3, 1, 0)) * -1.0
    rdm2_f_ovoo += einsum(x3, (0, 1, 2, 3), (2, 3, 0, 1))
    rdm2_f_ovoo += einsum(x3, (0, 1, 2, 3), (2, 3, 1, 0)) * -1.0
    rdm2_f_vooo += einsum(x3, (0, 1, 2, 3), (3, 2, 0, 1)) * -1.0
    rdm2_f_vooo += einsum(x3, (0, 1, 2, 3), (3, 2, 1, 0))
    rdm2_f_vooo += einsum(x3, (0, 1, 2, 3), (3, 2, 0, 1)) * -1.0
    rdm2_f_vooo += einsum(x3, (0, 1, 2, 3), (3, 2, 0, 1)) * -1.0
    rdm2_f_vooo += einsum(x3, (0, 1, 2, 3), (3, 2, 0, 1)) * -1.0
    rdm2_f_vooo += einsum(x3, (0, 1, 2, 3), (3, 2, 1, 0))
    x4 = np.zeros((nocc, nocc, nocc, nocc), dtype=types[float])
    x4 += einsum(t1, (0, 1), x3, (2, 3, 4, 1), (2, 3, 0, 4))
    rdm2_f_oooo += einsum(x4, (0, 1, 2, 3), (3, 2, 1, 0))
    rdm2_f_oooo += einsum(x4, (0, 1, 2, 3), (3, 2, 1, 0))
    x5 = np.zeros((nocc, nocc, nocc, nocc), dtype=types[float])
    x5 += einsum(x2, (0, 1, 2, 3), (1, 0, 3, 2))
    x5 += einsum(x4, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_oooo += einsum(x5, (0, 1, 2, 3), (3, 2, 0, 1)) * -1.0
    rdm2_f_oooo += einsum(x5, (0, 1, 2, 3), (2, 3, 0, 1))
    rdm2_f_oooo += einsum(x5, (0, 1, 2, 3), (3, 2, 0, 1)) * -1.0
    rdm2_f_oooo += einsum(x5, (0, 1, 2, 3), (2, 3, 0, 1))
    x6 = np.zeros((nocc, nocc), dtype=types[float])
    x6 += einsum(l1, (0, 1), t1, (2, 0), (1, 2))
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x6, (2, 3), (0, 3, 1, 2)) * -1.0
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x6, (2, 3), (3, 0, 1, 2))
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x6, (2, 3), (0, 3, 2, 1))
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x6, (2, 3), (3, 0, 2, 1)) * -1.0
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x6, (2, 3), (0, 3, 1, 2)) * -1.0
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x6, (2, 3), (3, 0, 2, 1)) * -1.0
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x6, (2, 3), (0, 3, 1, 2)) * -1.0
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x6, (2, 3), (3, 0, 2, 1)) * -1.0
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x6, (2, 3), (0, 3, 1, 2)) * -1.0
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x6, (2, 3), (3, 0, 1, 2))
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x6, (2, 3), (0, 3, 2, 1))
    rdm2_f_oooo += einsum(delta.oo, (0, 1), x6, (2, 3), (3, 0, 2, 1)) * -1.0
    x7 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x7 += einsum(l1, (0, 1), t2, (2, 3, 4, 0), (1, 2, 3, 4))
    rdm2_f_ooov = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    rdm2_f_ooov += einsum(x7, (0, 1, 2, 3), (2, 1, 0, 3)) * -1.0
    rdm2_f_ooov += einsum(x7, (0, 1, 2, 3), (2, 1, 0, 3)) * -1.0
    rdm2_f_oovo = np.zeros((nocc, nocc, nvir, nocc), dtype=types[float])
    rdm2_f_oovo += einsum(x7, (0, 1, 2, 3), (1, 2, 3, 0)) * -1.0
    rdm2_f_oovo += einsum(x7, (0, 1, 2, 3), (1, 2, 3, 0)) * -1.0
    x8 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x8 += einsum(x3, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    x8 += einsum(x3, (0, 1, 2, 3), (1, 0, 2, 3))
    x9 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x9 += einsum(t2, (0, 1, 2, 3), x8, (1, 4, 5, 2), (4, 5, 0, 3))
    del x8
    x10 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x10 += einsum(x3, (0, 1, 2, 3), (0, 1, 2, 3))
    x10 += einsum(x3, (0, 1, 2, 3), (1, 0, 2, 3)) * -0.5
    x11 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x11 += einsum(t2, (0, 1, 2, 3), x10, (1, 4, 5, 3), (4, 5, 0, 2)) * 2.0
    del x10
    x12 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x12 += einsum(t1, (0, 1), x5, (0, 2, 3, 4), (2, 3, 4, 1))
    del x5
    rdm2_f_ooov += einsum(x12, (0, 1, 2, 3), (2, 1, 0, 3))
    rdm2_f_ooov += einsum(x12, (0, 1, 2, 3), (2, 1, 0, 3))
    rdm2_f_oovo += einsum(x12, (0, 1, 2, 3), (1, 2, 3, 0))
    rdm2_f_oovo += einsum(x12, (0, 1, 2, 3), (1, 2, 3, 0))
    x13 = np.zeros((nocc, nocc), dtype=types[float])
    x13 += einsum(l2, (0, 1, 2, 3), x0, (2, 4, 1, 0), (3, 4)) * 2.0
    del x0
    x14 = np.zeros((nocc, nocc), dtype=types[float])
    x14 += einsum(x6, (0, 1), (0, 1))
    x14 += einsum(x13, (0, 1), (0, 1))
    rdm2_f_ooov += einsum(t1, (0, 1), x14, (2, 3), (3, 0, 2, 1)) * -1.0
    rdm2_f_ooov += einsum(t1, (0, 1), x14, (2, 3), (3, 0, 2, 1)) * -1.0
    x15 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x15 += einsum(delta.oo, (0, 1), t1, (2, 3), (0, 1, 2, 3))
    x15 += einsum(x7, (0, 1, 2, 3), (1, 0, 2, 3))
    x15 += einsum(x9, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    del x9
    x15 += einsum(x11, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    del x11
    x15 += einsum(x12, (0, 1, 2, 3), (2, 0, 1, 3))
    x15 += einsum(t1, (0, 1), x14, (2, 3), (0, 2, 3, 1))
    rdm2_f_ooov += einsum(x15, (0, 1, 2, 3), (0, 2, 1, 3))
    rdm2_f_ooov += einsum(x15, (0, 1, 2, 3), (2, 0, 1, 3)) * -1.0
    rdm2_f_ooov += einsum(x15, (0, 1, 2, 3), (0, 2, 1, 3))
    rdm2_f_ooov += einsum(x15, (0, 1, 2, 3), (2, 0, 1, 3)) * -1.0
    rdm2_f_oovo += einsum(x15, (0, 1, 2, 3), (0, 2, 3, 1)) * -1.0
    rdm2_f_oovo += einsum(x15, (0, 1, 2, 3), (2, 0, 3, 1))
    rdm2_f_oovo += einsum(x15, (0, 1, 2, 3), (0, 2, 3, 1)) * -1.0
    rdm2_f_oovo += einsum(x15, (0, 1, 2, 3), (2, 0, 3, 1))
    del x15
    x16 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x16 += einsum(x3, (0, 1, 2, 3), (0, 1, 2, 3)) * -0.5
    x16 += einsum(x3, (0, 1, 2, 3), (1, 0, 2, 3))
    x17 = np.zeros((nocc, nvir), dtype=types[float])
    x17 += einsum(t2, (0, 1, 2, 3), x16, (0, 1, 4, 3), (4, 2)) * 2.0
    x18 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x18 += einsum(t2, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    x18 += einsum(t2, (0, 1, 2, 3), (0, 1, 2, 3)) * 2.0
    x19 = np.zeros((nocc, nvir), dtype=types[float])
    x19 += einsum(l1, (0, 1), x18, (1, 2, 0, 3), (2, 3))
    x20 = np.zeros((nocc, nvir), dtype=types[float])
    x20 += einsum(t1, (0, 1), x14, (0, 2), (2, 1))
    x21 = np.zeros((nocc, nvir), dtype=types[float])
    x21 += einsum(x17, (0, 1), (0, 1))
    x21 += einsum(x19, (0, 1), (0, 1)) * -1.0
    x21 += einsum(x20, (0, 1), (0, 1))
    rdm2_f_ooov += einsum(delta.oo, (0, 1), x21, (2, 3), (0, 2, 1, 3)) * -1.0
    rdm2_f_ooov += einsum(delta.oo, (0, 1), x21, (2, 3), (2, 0, 1, 3))
    rdm2_f_ooov += einsum(delta.oo, (0, 1), x21, (2, 3), (0, 2, 1, 3)) * -1.0
    rdm2_f_ooov += einsum(delta.oo, (0, 1), x21, (2, 3), (2, 0, 1, 3))
    rdm2_f_oovo += einsum(delta.oo, (0, 1), x21, (2, 3), (0, 2, 3, 1))
    rdm2_f_oovo += einsum(delta.oo, (0, 1), x21, (2, 3), (2, 0, 3, 1)) * -1.0
    rdm2_f_oovo += einsum(delta.oo, (0, 1), x21, (2, 3), (0, 2, 3, 1))
    rdm2_f_oovo += einsum(delta.oo, (0, 1), x21, (2, 3), (2, 0, 3, 1)) * -1.0
    del x21
    x22 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x22 += einsum(t2, (0, 1, 2, 3), x3, (1, 4, 5, 2), (4, 5, 0, 3))
    rdm2_f_ooov += einsum(x22, (0, 1, 2, 3), (1, 2, 0, 3))
    rdm2_f_ooov += einsum(x22, (0, 1, 2, 3), (1, 2, 0, 3))
    rdm2_f_oovo += einsum(x22, (0, 1, 2, 3), (2, 1, 3, 0))
    rdm2_f_oovo += einsum(x22, (0, 1, 2, 3), (2, 1, 3, 0))
    del x22
    x23 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x23 += einsum(t2, (0, 1, 2, 3), x3, (4, 1, 5, 2), (4, 5, 0, 3))
    rdm2_f_ooov += einsum(x23, (0, 1, 2, 3), (2, 1, 0, 3))
    rdm2_f_ooov += einsum(x23, (0, 1, 2, 3), (2, 1, 0, 3))
    rdm2_f_oovo += einsum(x23, (0, 1, 2, 3), (1, 2, 3, 0))
    rdm2_f_oovo += einsum(x23, (0, 1, 2, 3), (1, 2, 3, 0))
    x24 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x24 += einsum(x3, (0, 1, 2, 3), (0, 1, 2, 3)) * 2.0
    x24 += einsum(x3, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    x25 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x25 += einsum(t2, (0, 1, 2, 3), x24, (1, 4, 5, 3), (4, 5, 0, 2))
    del x24
    rdm2_f_ooov += einsum(x25, (0, 1, 2, 3), (1, 2, 0, 3)) * -1.0
    rdm2_f_ooov += einsum(x25, (0, 1, 2, 3), (1, 2, 0, 3)) * -1.0
    rdm2_f_oovo += einsum(x25, (0, 1, 2, 3), (2, 1, 3, 0)) * -1.0
    rdm2_f_oovo += einsum(x25, (0, 1, 2, 3), (2, 1, 3, 0)) * -1.0
    del x25
    x26 = np.zeros((nocc, nvir), dtype=types[float])
    x26 += einsum(t1, (0, 1), (0, 1)) * -1.0
    x26 += einsum(x17, (0, 1), (0, 1))
    del x17
    x26 += einsum(x19, (0, 1), (0, 1)) * -1.0
    del x19
    x26 += einsum(x20, (0, 1), (0, 1))
    del x20
    rdm2_f_ooov += einsum(delta.oo, (0, 1), x26, (2, 3), (0, 2, 1, 3)) * -1.0
    rdm2_f_ooov += einsum(delta.oo, (0, 1), x26, (2, 3), (0, 2, 1, 3)) * -1.0
    del x26
    x27 = np.zeros((nocc, nocc), dtype=types[float])
    x27 += einsum(delta.oo, (0, 1), (0, 1)) * -1.0
    x27 += einsum(x6, (0, 1), (0, 1))
    x27 += einsum(x13, (0, 1), (0, 1))
    rdm2_f_oovo += einsum(t1, (0, 1), x27, (2, 3), (0, 3, 1, 2)) * -1.0
    rdm2_f_oovo += einsum(t1, (0, 1), x27, (2, 3), (0, 3, 1, 2)) * -1.0
    del x27
    x28 = np.zeros((nocc, nvir), dtype=types[float])
    x28 += einsum(t2, (0, 1, 2, 3), x16, (0, 1, 4, 3), (4, 2))
    x29 = np.zeros((nocc, nvir), dtype=types[float])
    x29 += einsum(l1, (0, 1), x18, (1, 2, 0, 3), (2, 3)) * 0.5
    x30 = np.zeros((nocc, nvir), dtype=types[float])
    x30 += einsum(t1, (0, 1), x14, (0, 2), (2, 1)) * 0.5
    del x14
    x31 = np.zeros((nocc, nvir), dtype=types[float])
    x31 += einsum(x28, (0, 1), (0, 1))
    x31 += einsum(x29, (0, 1), (0, 1)) * -1.0
    x31 += einsum(x30, (0, 1), (0, 1))
    del x30
    rdm2_f_oovo += einsum(delta.oo, (0, 1), x31, (2, 3), (2, 0, 3, 1)) * -2.0
    rdm2_f_oovo += einsum(delta.oo, (0, 1), x31, (2, 3), (2, 0, 3, 1)) * -2.0
    x32 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x32 += einsum(t2, (0, 1, 2, 3), x2, (0, 1, 4, 5), (4, 5, 2, 3))
    del x2
    rdm2_f_oovv += einsum(x32, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_oovv += einsum(x32, (0, 1, 2, 3), (0, 1, 2, 3))
    x33 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x33 += einsum(t2, (0, 1, 2, 3), x4, (1, 0, 4, 5), (4, 5, 3, 2))
    del x4
    rdm2_f_oovv += einsum(x33, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_oovv += einsum(x33, (0, 1, 2, 3), (0, 1, 2, 3))
    x34 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x34 += einsum(l2, (0, 1, 2, 3), (3, 2, 0, 1)) * -0.5
    x34 += einsum(l2, (0, 1, 2, 3), (2, 3, 0, 1))
    x35 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x35 += einsum(t2, (0, 1, 2, 3), x34, (1, 4, 3, 5), (4, 0, 5, 2))
    x36 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x36 += einsum(t2, (0, 1, 2, 3), x35, (1, 4, 3, 5), (4, 0, 5, 2)) * 4.0
    del x35
    x37 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x37 += einsum(l2, (0, 1, 2, 3), (3, 2, 0, 1))
    x37 += einsum(l2, (0, 1, 2, 3), (2, 3, 0, 1)) * -1.0
    x38 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x38 += einsum(t2, (0, 1, 2, 3), x37, (1, 4, 2, 5), (4, 0, 5, 3))
    del x37
    x39 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x39 += einsum(t2, (0, 1, 2, 3), x38, (1, 4, 2, 5), (4, 0, 5, 3)) * -1.0
    del x38
    x40 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x40 += einsum(t1, (0, 1), x12, (0, 2, 3, 4), (3, 2, 4, 1))
    del x12
    rdm2_f_oovv += einsum(x40, (0, 1, 2, 3), (0, 1, 3, 2))
    rdm2_f_oovv += einsum(x40, (0, 1, 2, 3), (0, 1, 3, 2))
    x41 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x41 += einsum(x32, (0, 1, 2, 3), (0, 1, 2, 3))
    del x32
    x41 += einsum(x33, (0, 1, 2, 3), (0, 1, 2, 3))
    del x33
    x41 += einsum(x36, (0, 1, 2, 3), (1, 0, 3, 2))
    del x36
    x41 += einsum(x39, (0, 1, 2, 3), (0, 1, 2, 3))
    del x39
    x41 += einsum(x40, (0, 1, 2, 3), (0, 1, 3, 2))
    del x40
    rdm2_f_oovv += einsum(x41, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_oovv += einsum(x41, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    rdm2_f_oovv += einsum(x41, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_oovv += einsum(x41, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    del x41
    x42 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x42 += einsum(x6, (0, 1), t2, (2, 0, 3, 4), (1, 2, 3, 4))
    x43 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x43 += einsum(t2, (0, 1, 2, 3), x34, (1, 4, 2, 5), (4, 0, 5, 3)) * 2.0
    x44 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x44 += einsum(t2, (0, 1, 2, 3), x43, (1, 4, 3, 5), (4, 0, 5, 2))
    del x43
    x45 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x45 += einsum(l2, (0, 1, 2, 3), (3, 2, 0, 1))
    x45 += einsum(l2, (0, 1, 2, 3), (2, 3, 0, 1)) * -0.5
    x46 = np.zeros((nvir, nvir), dtype=types[float])
    x46 += einsum(t2, (0, 1, 2, 3), x45, (0, 1, 3, 4), (4, 2)) * 2.0
    x47 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x47 += einsum(x46, (0, 1), t2, (2, 3, 0, 4), (2, 3, 1, 4))
    x48 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x48 += einsum(x3, (0, 1, 2, 3), (0, 1, 2, 3))
    x48 += einsum(x3, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    x49 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x49 += einsum(t2, (0, 1, 2, 3), x48, (4, 1, 5, 2), (4, 5, 0, 3))
    x50 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x50 += einsum(t2, (0, 1, 2, 3), x16, (4, 1, 5, 3), (4, 5, 0, 2)) * 2.0
    del x16
    x51 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x51 += einsum(x7, (0, 1, 2, 3), (0, 1, 2, 3))
    x51 += einsum(x49, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x49
    x51 += einsum(x50, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x50
    x52 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x52 += einsum(t1, (0, 1), x51, (0, 2, 3, 4), (2, 3, 4, 1))
    del x51
    x53 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x53 += einsum(x13, (0, 1), t2, (2, 0, 3, 4), (1, 2, 4, 3))
    del x13
    x54 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x54 += einsum(x42, (0, 1, 2, 3), (0, 1, 2, 3))
    x54 += einsum(x44, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    x54 += einsum(x47, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    x54 += einsum(x52, (0, 1, 2, 3), (0, 1, 3, 2))
    del x52
    x54 += einsum(x53, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    x54 += einsum(t1, (0, 1), x31, (2, 3), (0, 2, 1, 3)) * -2.0
    del x31
    rdm2_f_oovv += einsum(x54, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_oovv += einsum(x54, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    rdm2_f_oovv += einsum(x54, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    rdm2_f_oovv += einsum(x54, (0, 1, 2, 3), (1, 0, 3, 2))
    rdm2_f_oovv += einsum(x54, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_oovv += einsum(x54, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    rdm2_f_oovv += einsum(x54, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    rdm2_f_oovv += einsum(x54, (0, 1, 2, 3), (1, 0, 3, 2))
    del x54
    x55 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x55 += einsum(t2, (0, 1, 2, 3), (0, 1, 2, 3))
    x55 += einsum(t1, (0, 1), t1, (2, 3), (0, 2, 1, 3))
    rdm2_f_oovv += einsum(x55, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    rdm2_f_oovv += einsum(x55, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_oovv += einsum(x55, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    rdm2_f_oovv += einsum(x55, (0, 1, 2, 3), (0, 1, 2, 3))
    del x55
    x56 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x56 += einsum(l2, (0, 1, 2, 3), t2, (4, 3, 1, 5), (2, 4, 0, 5))
    x57 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x57 += einsum(t2, (0, 1, 2, 3), x56, (1, 4, 2, 5), (0, 4, 3, 5))
    del x56
    rdm2_f_oovv += einsum(x57, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_oovv += einsum(x57, (0, 1, 2, 3), (0, 1, 2, 3))
    del x57
    x58 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x58 += einsum(l2, (0, 1, 2, 3), t2, (4, 2, 1, 5), (3, 4, 0, 5))
    rdm2_f_ovov += einsum(x58, (0, 1, 2, 3), (1, 2, 0, 3)) * -1.0
    rdm2_f_ovov += einsum(x58, (0, 1, 2, 3), (1, 2, 0, 3)) * -1.0
    rdm2_f_vovo += einsum(x58, (0, 1, 2, 3), (2, 1, 3, 0)) * -1.0
    rdm2_f_vovo += einsum(x58, (0, 1, 2, 3), (2, 1, 3, 0)) * -1.0
    x59 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x59 += einsum(t2, (0, 1, 2, 3), x58, (1, 4, 2, 5), (0, 4, 3, 5))
    rdm2_f_oovv += einsum(x59, (0, 1, 2, 3), (0, 1, 3, 2))
    rdm2_f_oovv += einsum(x59, (0, 1, 2, 3), (0, 1, 3, 2))
    del x59
    x60 = np.zeros((nocc, nvir), dtype=types[float])
    x60 += einsum(t1, (0, 1), x6, (0, 2), (2, 1))
    del x6
    rdm2_f_oovv += einsum(t1, (0, 1), x60, (2, 3), (2, 0, 3, 1)) * -1.0
    rdm2_f_oovv += einsum(t1, (0, 1), x60, (2, 3), (2, 0, 3, 1)) * -1.0
    x61 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x61 += einsum(t2, (0, 1, 2, 3), x3, (4, 1, 5, 3), (4, 5, 0, 2))
    x62 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x62 += einsum(x18, (0, 1, 2, 3), x3, (0, 4, 5, 2), (1, 4, 5, 3))
    del x18
    x63 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x63 += einsum(x61, (0, 1, 2, 3), (0, 1, 2, 3))
    del x61
    x63 += einsum(x62, (0, 1, 2, 3), (1, 2, 0, 3)) * -1.0
    del x62
    x64 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x64 += einsum(t1, (0, 1), x63, (0, 2, 3, 4), (2, 3, 4, 1))
    del x63
    x65 = np.zeros((nocc, nvir), dtype=types[float])
    x65 += einsum(t1, (0, 1), x1, (0, 2), (2, 1))
    del x1
    x66 = np.zeros((nocc, nvir), dtype=types[float])
    x66 += einsum(x28, (0, 1), (0, 1))
    del x28
    x66 += einsum(x29, (0, 1), (0, 1)) * -1.0
    del x29
    x66 += einsum(x65, (0, 1), (0, 1))
    del x65
    x67 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x67 += einsum(x44, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    del x44
    x67 += einsum(x47, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    del x47
    x67 += einsum(x64, (0, 1, 2, 3), (0, 1, 3, 2))
    del x64
    x67 += einsum(x53, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    del x53
    x67 += einsum(t1, (0, 1), x66, (2, 3), (0, 2, 1, 3)) * -2.0
    del x66
    rdm2_f_oovv += einsum(x67, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_oovv += einsum(x67, (0, 1, 2, 3), (1, 0, 3, 2))
    rdm2_f_oovv += einsum(x67, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_oovv += einsum(x67, (0, 1, 2, 3), (1, 0, 3, 2))
    del x67
    x68 = np.zeros((nocc, nocc, nocc, nvir), dtype=types[float])
    x68 += einsum(x7, (0, 1, 2, 3), (0, 1, 2, 3))
    del x7
    x68 += einsum(x23, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x23
    x69 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x69 += einsum(t1, (0, 1), x68, (0, 2, 3, 4), (2, 3, 4, 1))
    del x68
    x70 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x70 += einsum(x42, (0, 1, 2, 3), (0, 1, 2, 3))
    del x42
    x70 += einsum(x69, (0, 1, 2, 3), (0, 1, 3, 2))
    del x69
    rdm2_f_oovv += einsum(x70, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    rdm2_f_oovv += einsum(x70, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    rdm2_f_oovv += einsum(x70, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    rdm2_f_oovv += einsum(x70, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    del x70
    x71 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x71 += einsum(t2, (0, 1, 2, 3), x34, (1, 4, 3, 5), (4, 0, 5, 2)) * 2.0
    del x34
    x72 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x72 += einsum(t2, (0, 1, 2, 3), x71, (1, 4, 3, 5), (4, 0, 5, 2)) * 2.0
    del x71
    rdm2_f_oovv += einsum(x72, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_oovv += einsum(x72, (0, 1, 2, 3), (0, 1, 2, 3))
    del x72
    x73 = np.zeros((nocc, nvir), dtype=types[float])
    x73 += einsum(t1, (0, 1), (0, 1)) * -1.0
    x73 += einsum(x60, (0, 1), (0, 1))
    del x60
    rdm2_f_oovv += einsum(t1, (0, 1), x73, (2, 3), (0, 2, 1, 3)) * -1.0
    rdm2_f_oovv += einsum(t1, (0, 1), x73, (2, 3), (0, 2, 1, 3)) * -1.0
    del x73
    x74 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x74 += einsum(t2, (0, 1, 2, 3), (0, 1, 3, 2))
    x74 += einsum(t2, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    x75 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x75 += einsum(l2, (0, 1, 2, 3), x74, (2, 4, 1, 5), (4, 3, 5, 0))
    rdm2_f_ovov += einsum(x75, (0, 1, 2, 3), (0, 3, 1, 2)) * -1.0
    rdm2_f_ovov += einsum(x75, (0, 1, 2, 3), (0, 3, 1, 2)) * -1.0
    del x75
    x76 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x76 += einsum(t2, (0, 1, 2, 3), (0, 1, 3, 2)) * -0.5
    x76 += einsum(t2, (0, 1, 2, 3), (0, 1, 2, 3))
    x77 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x77 += einsum(l2, (0, 1, 2, 3), x76, (3, 4, 1, 5), (4, 2, 5, 0)) * 2.0
    del x76
    rdm2_f_ovov += einsum(x77, (0, 1, 2, 3), (0, 3, 1, 2)) * -1.0
    rdm2_f_ovov += einsum(x77, (0, 1, 2, 3), (0, 3, 1, 2)) * -1.0
    rdm2_f_voov += einsum(x77, (0, 1, 2, 3), (3, 0, 1, 2))
    rdm2_f_voov += einsum(x77, (0, 1, 2, 3), (3, 0, 1, 2))
    del x77
    x78 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x78 += einsum(t1, (0, 1), x48, (0, 2, 3, 4), (2, 3, 4, 1))
    rdm2_f_ovov += einsum(x78, (0, 1, 2, 3), (1, 2, 0, 3)) * -1.0
    rdm2_f_ovov += einsum(x78, (0, 1, 2, 3), (1, 2, 0, 3)) * -1.0
    rdm2_f_vovo += einsum(x78, (0, 1, 2, 3), (2, 1, 3, 0)) * -1.0
    rdm2_f_vovo += einsum(x78, (0, 1, 2, 3), (2, 1, 3, 0)) * -1.0
    del x78
    x79 = np.zeros((nvir, nvir), dtype=types[float])
    x79 += einsum(l1, (0, 1), t1, (1, 2), (0, 2))
    x80 = np.zeros((nvir, nvir), dtype=types[float])
    x80 += einsum(x79, (0, 1), (0, 1))
    x80 += einsum(x46, (0, 1), (0, 1))
    del x46
    rdm2_f_ovov += einsum(delta.oo, (0, 1), x80, (2, 3), (0, 2, 1, 3))
    rdm2_f_ovov += einsum(delta.oo, (0, 1), x80, (2, 3), (0, 2, 1, 3))
    rdm2_f_ovov += einsum(delta.oo, (0, 1), x80, (2, 3), (0, 2, 1, 3))
    rdm2_f_ovov += einsum(delta.oo, (0, 1), x80, (2, 3), (0, 2, 1, 3))
    rdm2_f_voov += einsum(delta.oo, (0, 1), x80, (2, 3), (2, 0, 1, 3)) * -1.0
    rdm2_f_voov += einsum(delta.oo, (0, 1), x80, (2, 3), (2, 0, 1, 3)) * -1.0
    rdm2_f_vovo += einsum(delta.oo, (0, 1), x80, (2, 3), (2, 0, 3, 1))
    rdm2_f_vovo += einsum(delta.oo, (0, 1), x80, (2, 3), (2, 0, 3, 1))
    rdm2_f_vovo += einsum(delta.oo, (0, 1), x80, (2, 3), (2, 0, 3, 1))
    rdm2_f_vovo += einsum(delta.oo, (0, 1), x80, (2, 3), (2, 0, 3, 1))
    rdm2_f_ovvv = np.zeros((nocc, nvir, nvir, nvir), dtype=types[float])
    rdm2_f_ovvv += einsum(t1, (0, 1), x80, (2, 3), (0, 2, 1, 3))
    rdm2_f_ovvv += einsum(t1, (0, 1), x80, (2, 3), (0, 2, 1, 3))
    rdm2_f_vovv = np.zeros((nvir, nocc, nvir, nvir), dtype=types[float])
    rdm2_f_vovv += einsum(t1, (0, 1), x80, (2, 3), (2, 0, 3, 1))
    rdm2_f_vovv += einsum(t1, (0, 1), x80, (2, 3), (2, 0, 3, 1))
    x81 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x81 += einsum(t1, (0, 1), x3, (0, 2, 3, 4), (2, 3, 4, 1))
    rdm2_f_ovov += einsum(x81, (0, 1, 2, 3), (1, 2, 0, 3)) * -1.0
    rdm2_f_ovov += einsum(x81, (0, 1, 2, 3), (1, 2, 0, 3)) * -1.0
    rdm2_f_vovo += einsum(x81, (0, 1, 2, 3), (2, 1, 3, 0)) * -1.0
    rdm2_f_vovo += einsum(x81, (0, 1, 2, 3), (2, 1, 3, 0)) * -1.0
    del x81
    x82 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x82 += einsum(l2, (0, 1, 2, 3), (3, 2, 0, 1)) * -1.0
    x82 += einsum(l2, (0, 1, 2, 3), (2, 3, 0, 1))
    x83 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x83 += einsum(t2, (0, 1, 2, 3), x82, (1, 4, 2, 5), (4, 0, 5, 3))
    del x82
    rdm2_f_ovvo += einsum(x83, (0, 1, 2, 3), (1, 2, 3, 0)) * -1.0
    rdm2_f_ovvo += einsum(x83, (0, 1, 2, 3), (1, 2, 3, 0)) * -1.0
    rdm2_f_vovo += einsum(x83, (0, 1, 2, 3), (2, 1, 3, 0))
    rdm2_f_vovo += einsum(x83, (0, 1, 2, 3), (2, 1, 3, 0))
    del x83
    x84 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x84 += einsum(l2, (0, 1, 2, 3), (3, 2, 0, 1)) * -1.0
    x84 += einsum(l2, (0, 1, 2, 3), (2, 3, 0, 1)) * 2.0
    x85 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x85 += einsum(t2, (0, 1, 2, 3), x84, (1, 4, 3, 5), (4, 0, 5, 2))
    del x84
    rdm2_f_ovvo += einsum(x85, (0, 1, 2, 3), (1, 2, 3, 0))
    rdm2_f_ovvo += einsum(x85, (0, 1, 2, 3), (1, 2, 3, 0))
    rdm2_f_vovo += einsum(x85, (0, 1, 2, 3), (2, 1, 3, 0)) * -1.0
    rdm2_f_vovo += einsum(x85, (0, 1, 2, 3), (2, 1, 3, 0)) * -1.0
    del x85
    x86 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x86 += einsum(t1, (0, 1), x48, (2, 0, 3, 4), (2, 3, 4, 1))
    del x48
    rdm2_f_ovvo += einsum(x86, (0, 1, 2, 3), (1, 2, 3, 0)) * -1.0
    rdm2_f_ovvo += einsum(x86, (0, 1, 2, 3), (1, 2, 3, 0)) * -1.0
    rdm2_f_voov += einsum(x86, (0, 1, 2, 3), (2, 1, 0, 3)) * -1.0
    rdm2_f_voov += einsum(x86, (0, 1, 2, 3), (2, 1, 0, 3)) * -1.0
    del x86
    x87 = np.zeros((nvir, nvir), dtype=types[float])
    x87 += einsum(t2, (0, 1, 2, 3), x45, (0, 1, 3, 4), (4, 2))
    del x45
    x88 = np.zeros((nvir, nvir), dtype=types[float])
    x88 += einsum(x79, (0, 1), (0, 1)) * 0.5
    del x79
    x88 += einsum(x87, (0, 1), (0, 1))
    del x87
    rdm2_f_ovvo += einsum(delta.oo, (0, 1), x88, (2, 3), (0, 2, 3, 1)) * -2.0
    rdm2_f_ovvo += einsum(delta.oo, (0, 1), x88, (2, 3), (0, 2, 3, 1)) * -2.0
    del x88
    x89 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x89 += einsum(l2, (0, 1, 2, 3), t2, (4, 2, 5, 1), (3, 4, 0, 5))
    rdm2_f_ovvo += einsum(x89, (0, 1, 2, 3), (1, 2, 3, 0)) * -1.0
    rdm2_f_ovvo += einsum(x89, (0, 1, 2, 3), (1, 2, 3, 0)) * -1.0
    rdm2_f_voov += einsum(x89, (0, 1, 2, 3), (2, 1, 0, 3)) * -1.0
    rdm2_f_voov += einsum(x89, (0, 1, 2, 3), (2, 1, 0, 3)) * -1.0
    x90 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x90 += einsum(t1, (0, 1), x3, (2, 0, 3, 4), (2, 3, 4, 1))
    rdm2_f_ovvo += einsum(x90, (0, 1, 2, 3), (1, 2, 3, 0)) * -1.0
    rdm2_f_ovvo += einsum(x90, (0, 1, 2, 3), (1, 2, 3, 0)) * -1.0
    rdm2_f_voov += einsum(x90, (0, 1, 2, 3), (2, 1, 0, 3)) * -1.0
    rdm2_f_voov += einsum(x90, (0, 1, 2, 3), (2, 1, 0, 3)) * -1.0
    x91 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x91 += einsum(t2, (0, 1, 2, 3), (0, 1, 3, 2)) * 2.0
    x91 += einsum(t2, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    x92 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x92 += einsum(l2, (0, 1, 2, 3), x91, (3, 4, 5, 1), (4, 2, 5, 0))
    rdm2_f_ovvo += einsum(x92, (0, 1, 2, 3), (0, 3, 2, 1))
    rdm2_f_ovvo += einsum(x92, (0, 1, 2, 3), (0, 3, 2, 1))
    rdm2_f_voov += einsum(x92, (0, 1, 2, 3), (3, 0, 1, 2))
    rdm2_f_voov += einsum(x92, (0, 1, 2, 3), (3, 0, 1, 2))
    x93 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x93 += einsum(l2, (0, 1, 2, 3), x74, (2, 4, 5, 1), (4, 3, 5, 0))
    del x74
    rdm2_f_voov += einsum(x93, (0, 1, 2, 3), (3, 0, 1, 2)) * -1.0
    rdm2_f_voov += einsum(x93, (0, 1, 2, 3), (3, 0, 1, 2)) * -1.0
    x94 = np.zeros((nocc, nvir, nvir, nvir), dtype=types[float])
    x94 += einsum(l1, (0, 1), t2, (2, 1, 3, 4), (2, 0, 3, 4))
    rdm2_f_ovvv += einsum(x94, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_ovvv += einsum(x94, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_vovv += einsum(x94, (0, 1, 2, 3), (1, 0, 3, 2))
    rdm2_f_vovv += einsum(x94, (0, 1, 2, 3), (1, 0, 3, 2))
    x95 = np.zeros((nocc, nvir, nvir, nvir), dtype=types[float])
    x95 += einsum(t2, (0, 1, 2, 3), x3, (0, 1, 4, 5), (4, 5, 2, 3))
    del x3
    rdm2_f_ovvv += einsum(x95, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    rdm2_f_ovvv += einsum(x95, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    rdm2_f_vovv += einsum(x95, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    rdm2_f_vovv += einsum(x95, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    x96 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x96 += einsum(x90, (0, 1, 2, 3), (0, 1, 2, 3))
    x96 += einsum(x92, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    x96 += einsum(x93, (0, 1, 2, 3), (1, 0, 3, 2))
    del x93
    x97 = np.zeros((nocc, nvir, nvir, nvir), dtype=types[float])
    x97 += einsum(t1, (0, 1), x96, (0, 2, 3, 4), (2, 3, 4, 1))
    del x96
    x98 = np.zeros((nocc, nvir, nvir, nvir), dtype=types[float])
    x98 += einsum(x94, (0, 1, 2, 3), (0, 1, 2, 3))
    del x94
    x98 += einsum(x95, (0, 1, 2, 3), (0, 1, 2, 3))
    del x95
    x98 += einsum(x97, (0, 1, 2, 3), (0, 1, 3, 2))
    del x97
    x98 += einsum(t1, (0, 1), x80, (2, 3), (0, 2, 1, 3))
    del x80
    rdm2_f_ovvv += einsum(x98, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_ovvv += einsum(x98, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    rdm2_f_ovvv += einsum(x98, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_ovvv += einsum(x98, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    rdm2_f_vovv += einsum(x98, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    rdm2_f_vovv += einsum(x98, (0, 1, 2, 3), (1, 0, 3, 2))
    rdm2_f_vovv += einsum(x98, (0, 1, 2, 3), (1, 0, 2, 3)) * -1.0
    rdm2_f_vovv += einsum(x98, (0, 1, 2, 3), (1, 0, 3, 2))
    del x98
    x99 = np.zeros((nocc, nvir, nvir, nvir), dtype=types[float])
    x99 += einsum(t1, (0, 1), x58, (0, 2, 3, 4), (2, 3, 1, 4))
    del x58
    rdm2_f_ovvv += einsum(x99, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    rdm2_f_ovvv += einsum(x99, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    rdm2_f_vovv += einsum(x99, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    rdm2_f_vovv += einsum(x99, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    del x99
    x100 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x100 += einsum(x89, (0, 1, 2, 3), (0, 1, 2, 3))
    x100 += einsum(x90, (0, 1, 2, 3), (0, 1, 2, 3))
    x100 += einsum(x92, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    del x92
    x101 = np.zeros((nocc, nvir, nvir, nvir), dtype=types[float])
    x101 += einsum(t1, (0, 1), x100, (0, 2, 3, 4), (2, 3, 4, 1))
    del x100
    rdm2_f_ovvv += einsum(x101, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    rdm2_f_ovvv += einsum(x101, (0, 1, 2, 3), (0, 1, 2, 3)) * -1.0
    del x101
    x102 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x102 += einsum(l2, (0, 1, 2, 3), x91, (3, 4, 5, 1), (4, 2, 5, 0)) * 0.5
    del x91
    x103 = np.zeros((nocc, nocc, nvir, nvir), dtype=types[float])
    x103 += einsum(x89, (0, 1, 2, 3), (0, 1, 2, 3)) * 0.5
    del x89
    x103 += einsum(x90, (0, 1, 2, 3), (0, 1, 2, 3)) * 0.5
    del x90
    x103 += einsum(x102, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    del x102
    x104 = np.zeros((nocc, nvir, nvir, nvir), dtype=types[float])
    x104 += einsum(t1, (0, 1), x103, (0, 2, 3, 4), (2, 3, 4, 1)) * 2.0
    del x103
    rdm2_f_vovv += einsum(x104, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    rdm2_f_vovv += einsum(x104, (0, 1, 2, 3), (1, 0, 3, 2)) * -1.0
    del x104
    x105 = np.zeros((nocc, nvir, nvir, nvir), dtype=types[float])
    x105 += einsum(t1, (0, 1), l2, (2, 3, 4, 0), (4, 2, 3, 1))
    rdm2_f_vvov = np.zeros((nvir, nvir, nocc, nvir), dtype=types[float])
    rdm2_f_vvov += einsum(x105, (0, 1, 2, 3), (1, 2, 0, 3))
    rdm2_f_vvov += einsum(x105, (0, 1, 2, 3), (2, 1, 0, 3)) * -1.0
    rdm2_f_vvov += einsum(x105, (0, 1, 2, 3), (1, 2, 0, 3))
    rdm2_f_vvov += einsum(x105, (0, 1, 2, 3), (1, 2, 0, 3))
    rdm2_f_vvov += einsum(x105, (0, 1, 2, 3), (1, 2, 0, 3))
    rdm2_f_vvov += einsum(x105, (0, 1, 2, 3), (2, 1, 0, 3)) * -1.0
    rdm2_f_vvvo = np.zeros((nvir, nvir, nvir, nocc), dtype=types[float])
    rdm2_f_vvvo += einsum(x105, (0, 1, 2, 3), (1, 2, 3, 0)) * -1.0
    rdm2_f_vvvo += einsum(x105, (0, 1, 2, 3), (2, 1, 3, 0))
    rdm2_f_vvvo += einsum(x105, (0, 1, 2, 3), (2, 1, 3, 0))
    rdm2_f_vvvo += einsum(x105, (0, 1, 2, 3), (2, 1, 3, 0))
    rdm2_f_vvvo += einsum(x105, (0, 1, 2, 3), (1, 2, 3, 0)) * -1.0
    rdm2_f_vvvo += einsum(x105, (0, 1, 2, 3), (2, 1, 3, 0))
    x106 = np.zeros((nvir, nvir, nvir, nvir), dtype=types[float])
    x106 += einsum(l2, (0, 1, 2, 3), t2, (2, 3, 4, 5), (0, 1, 4, 5))
    rdm2_f_vvvv = np.zeros((nvir, nvir, nvir, nvir), dtype=types[float])
    rdm2_f_vvvv += einsum(x106, (0, 1, 2, 3), (1, 0, 3, 2))
    rdm2_f_vvvv += einsum(x106, (0, 1, 2, 3), (1, 0, 3, 2))
    x107 = np.zeros((nvir, nvir, nvir, nvir), dtype=types[float])
    x107 += einsum(t1, (0, 1), x105, (0, 2, 3, 4), (3, 2, 4, 1))
    del x105
    rdm2_f_vvvv += einsum(x107, (0, 1, 2, 3), (1, 0, 3, 2))
    rdm2_f_vvvv += einsum(x107, (0, 1, 2, 3), (1, 0, 3, 2))
    x108 = np.zeros((nvir, nvir, nvir, nvir), dtype=types[float])
    x108 += einsum(x106, (0, 1, 2, 3), (1, 0, 3, 2))
    del x106
    x108 += einsum(x107, (0, 1, 2, 3), (1, 0, 3, 2))
    del x107
    rdm2_f_vvvv += einsum(x108, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    rdm2_f_vvvv += einsum(x108, (0, 1, 2, 3), (0, 1, 2, 3))
    rdm2_f_vvvv += einsum(x108, (0, 1, 2, 3), (0, 1, 3, 2)) * -1.0
    rdm2_f_vvvv += einsum(x108, (0, 1, 2, 3), (0, 1, 2, 3))
    del x108

    rdm2_f = pack_2e(rdm2_f_oooo, rdm2_f_ooov, rdm2_f_oovo, rdm2_f_ovoo, rdm2_f_vooo, rdm2_f_oovv, rdm2_f_ovov, rdm2_f_ovvo, rdm2_f_voov, rdm2_f_vovo, rdm2_f_vvoo, rdm2_f_ovvv, rdm2_f_vovv, rdm2_f_vvov, rdm2_f_vvvo, rdm2_f_vvvv)

    rdm2_f = rdm2_f.swapaxes(1, 2)

    return rdm2_f

